/*
	Write & edit by Linjianghua(Xempo) 2004-2006, 2008-2011, 2012
	Free under LGPL
*/

#include "fspdir.h"

const char rootchs[]="/";

BOOL TempBrow;

void (*pGetPdExt)(fsp_dir *dir);

fsp_dir *pdAlloc()
{
fsp_dir *dir=(fsp_dir *)zalloc(sizeof(fsp_dir));
dir->mdf=FreeDirAlloc;
return dir;
}

// #ifdef  _STDIO_H
#define ZLMT  100
#define ZDIV  10
// #else

void setZero(fsp_dir *dir, int s)
{
if(isZero(dir->Format)){
	dir->zSize=s>0 ? s : (dir->selfnumbs<20 ? 3 : (dir->selfnumbs>1000 ? ZLMT :  dir->selfnumbs/ZDIV +1) );
	dir->zcache=(ZeroCache *)zalloc(  dir->zSize*sizeof(ZeroCache) );
	}
}

int getLenght(fsp_dir *dir)
{
int style=dir->Format;
return style&384 /*256|SimpleBase  data lib */ ? 
	FCU_NumPos : dir->DAUC * ( isType(style) ? sizeof(DAU)+1 : sizeof(DAU) )
	+ ( isZero(style) ? FCU_NumPos:FCU_NumPos+sizeof(int) );
}

fsp_dir *pdParent(fsp_dir *dir0, char *pth, char **fixname)
{
  if(pth){
    char *dn;
/*    for(dn=pth; *dn; dn++)
	if(*dn=='\\')*dn='/';*/
    dn=(char *)separChr(pth);
    if(dn==NULL)goto _jmp_;
    if(dn!=pth)*dn=0;
    else pth=(char *)rootchs;
    *fixname=dn+1;
    return pd_open(dir0, pth, DIR_READ);
  }
_jmp_: idxdscpt=0x7fff;
  *fixname=pth;
  if(dir0&&isNormDir(dir0))dir0->openMode++;
  return dir0;
}

int nameVerify(const char *dirnam)
{
static const char lmtstr[20]=
{ '\"', '*' , ';' , '\'', '?', ',', 9, 10, 13, 26, 32,':','=',
'[', ']', '<', '>', '#'   }; /* as # is datalib */
while(*dirnam=='.')dirnam++;
if(*dirnam==0||*dirnam=='-'||strchrs(dirnam,lmtstr)){ idxdscpt=InvName_13; return 0; }
return 1;
}

void setPdPara(fsp_dir *dir, const un_Int *pms)
{
    dir->Format=*pms&(Ch_Dir-1);
    dir->Num_FCUs_Block=pms[1];
    dir->Dir_FCUs_Block=pms[2];
    dir->DAUC=pms[3] ? (pms[3]>6000 ? 6000 : pms[3]) : 1;
    dir->mode=pms[4];
    dir->mdf|=NEW_DIR;
    dir->Num_FCU_Len=getLenght(dir);
}

fsp_dir *pdRead(fsp_lib *lib, fsp_dir *dirbuf, DirFCU *du, dskadr_t adr)
{
    int j;
    fsp_dir *dir;
    for(j=0; j<lib->cnt_usedir; j++){
	dir=lib->usedirs[j];
	if(dir->own_adr==adr){
		if(TempBrow==False)dir->openMode++;
		return dir;
	}
    }
    if(adr<1)return (fsp_dir *)lib;
    idxdscpt = dkread(lib,adr,&dirbuf->cur_numb_FCT,du? du->savelen:DIR_SAV_SIZ,1)<1 ? ErrScnFile_5:0x7fff;
    if(du)memcpy(&dirbuf->tag,du,Dir_FCU_Len);
    else dkread(lib,dirbuf->Own_FCU_Addr,&dirbuf->tag,Dir_FCU_Len,1);
    dirbuf->openMode=0;
    dirbuf->lib=lib;
    dirbuf->Num_FCU_Len=getLenght(dirbuf);
/*    dirbuf->name[DirNameLen-1]=0;*/
/*    dirbuf->mdf=0; */
    return dirbuf;
}

BOOL pdTest(fsp_lib *fsp, fsp_dir *dir)
{
if(fsp){
  int i;
  for(i=0; i<fsp->cnt_usedir; i++)
      if(fsp->usedirs[i]==dir)return True;
  if(dir==fsp->CurDir)fsp->CurDir=(fsp_dir *)fsp;
}
return False;
}

void pd_close(fsp_dir *dir, int mode)
{
if(dir && isNormDir(dir)){
  int i;
  fsp_lib *fsp;
//  if(pdTest(dir)==False)return;
  if(mode && dir->openMode ){
	--dir->openMode;
	return;
	}
  if(dir->mdf&63){ /* 64(FreeDirAlloc) is alloc */
     fspTime(0, dir->datebuf);
     pdSave(dir);
  }
#ifndef FSP_SMALL
  if(dir->DataType)free(dir->DataType);
#endif
  fsp=dir->lib;
  if(isZero(dir->Format))free(dir->zcache);
  if(dir->mdf&FreeDirAlloc)free(dir);
  for(i=0; i<fsp->cnt_usedir; i++)
      if(fsp->usedirs[i]==dir){
	while(i<fsp->cnt_usedir)fsp->usedirs[i++]=fsp->usedirs[i+1];
	fsp->cnt_usedir--;
	break;
	}
}
}

void addOpenList(fsp_dir *cdir)
{
if(isRoot(cdir))return;
fsp_lib *lib=cdir->lib;
if(lib->cnt_usedir>=lib->pre_usedir){
	lib->pre_usedir+=6;
	fsp_dir **usedirs=(fsp_dir **)malloc(sizeof(fsp_dir)*lib->pre_usedir);
	if(lib->cnt_usedir){
		int j;
		for(j=0; j<lib->cnt_usedir; j++)usedirs[j]=lib->usedirs[j];
		free(lib->usedirs);
	}
	lib->usedirs=usedirs;
}
setZero(cdir, 0);
lib->usedirs[lib->cnt_usedir++]=cdir;
}

fsp_dir *pd_open(fsp_dir *cdir, const char *path_nam, int _msg)
{
if(cdir){
 fsp_dir *dirbuff, *orgdir;
 DirFCU *dunit;
 int cn, i;
 char  *pthname, **dns;
 fsp_lib *lib=cdir->lib;
 idxdscpt=0x7fff;
 if(path_nam==NULL||*path_nam==0){
	if(isNormDir(cdir))cdir->openMode++;
	return cdir;
	}
 if(*path_nam=='\\' || *path_nam=='/')cdir=(fsp_dir *)lib;

 dirbuff=pdAlloc();
 pthname=strdup(path_nam);	path_nam=pthname;
 cn=10000;
 dns=setargv(pthname, "/\\", &cn);
 TempBrow=True;
 for(i=0; i<cn; i++){
   pthname=dns[i];	orgdir=cdir;
/*------------------ get special path ------------------*/
   if(*pthname=='.'&&pthname[1]=='.'){
 p_dir:	if(cdir->parent_adr<2)cdir=(fsp_dir *)lib;
	else cdir=pdRead(lib,dirbuff,NULL,cdir->parent_adr);
	switch((++pthname)[1]){
	case '.' : 	 goto p_dir;
	case 0 : 	continue;
	default : pthname=dns[i];	cdir=orgdir;
	}
   }
   else if(*pthname=='.')
	switch( pthname[1] ){
	case '/': pthname++; /* self-own */
	case 0 : pthname++;
	}
/* --- make extend function ---- get special path end ----------------- */

   if(*pthname==0)goto _ex_;
   if((dunit=pdSeek(cdir,pthname,_msg/* DIR_READ */))!=NULL)
	cdir=pdRead(lib,dirbuff,dunit,dunit->pDir);
   else {
	cdir=NULL;	   break;
	}
 }
_ex_: TempBrow=False;
 free((void *)path_nam);
 if(cdir!=dirbuff){
	free(dirbuff);
	if(cdir)cdir->openMode++;
	}
 if(cdir){
	if(cdir->openMode==0)addOpenList(cdir);
	if(pGetPdExt/*&&pthname!=path_nam*/)pGetPdExt(cdir);
	}
 return cdir;
}
idxdscpt=NoBuff_2;
return NULL;
}

fsp_dir *pd_creat(fsp_dir *odir, char *pth, const un_Int *pms)
{
if(odir){
fsp_dir *cdir=NULL, *dir=NULL;
char *dirnam;
fsp_lib *lib=odir->lib;
if(pth==NULL||*pth==0)idxdscpt=PthInv_7;
else if( (cdir=pdParent(odir, pth, &dirnam) ) )nameVerify(dirnam);

if(idxdscpt>0x7ffd){
    if((cdir->mode&FSP_OEM)&&(cdir->mdf&NEW_DIR/* Create */)==0)idxdscpt=OEM_Dir_10;
    else {
    DirFCU *dirUnit=pdSeek(cdir,dirnam,DIR_WRITE);
    if(idxdscpt>0x7ffd){
	dir=pdAlloc();
	memcpy(dir->name,dirnam,DirNamLen-1);
	dir->lib=lib;
	setPdPara(dir,pms);
	dir->tag=1;
	dir->savelen=*pms & SimpleBase ? DIR_SAV_SIZ+OFFLEN : DIR_SAV_SIZ;

	cdir->selfdirs+=1; cdir->selfsize+=dir->savelen;
	lib->tolDir+=1; cdir->mdf|=1;
	if(isNormDir(cdir))dir->parent_adr=cdir->own_adr;
	if(lib->FCU_dyw==0)creatFCT(cdir,cdir->Dir_FCUs_Block*Dir_FCU_Len+sizeof(dskadr_t), 0);
	dir->own_adr=dirUnit->pDir ? dirUnit->pDir:lib->fsz;
	dir->Own_FCU_Addr=lib->FCU_dyw;
	lib->useSize+=dir->savelen;
	lib->fsz+=dir->savelen;
	addOpenList(dir);
	fspTime(0, dir->datebuf);
	free(dirUnit);
	if(cdir==odir&&cdir->mdf&FIRST_FCT)pdSave(cdir);
     } /* creat sucesse */
  }
}
else if(idxdscpt==NoDir_6)idxdscpt=PthInv_7;

if( cdir!=odir )pd_close(cdir,1);
setZero(dir, 0);
return dir;
}
idxdscpt=NoBuff_2;
return NULL;
}
