/*
  Write & edit by Linjianghua 2004-2006
  Free under LGPL
*/
#include "fspdir.h"
#include "fspio.h"
#include "rebuild.h"

StrList fspPaths;

fsp_lib *fspAlloc()
{
fsp_lib *rtl=(fsp_lib *)zalloc(sizeof(fsp_lib));
rtl->CurDir=(fsp_dir *)rtl;
rtl->lib=rtl;
return rtl;
}

const char ExtFSP[]=".fsp";
fsp_lib *fspOpen(const char *filenam, int msg)
{
if(filenam){
 const char *oldfnm=filenam, *rc;
 BYTE  fspCtrl[blockSize];
 fsp_lib *lib;
 BOOL dect=msg&DectName;
 FILE *pff;
 idxdscpt=0x7fff;
 ropen: pff=dect ? fopen64(filenam,"rb+") : pathopen(filenam,R_OK|W_OK, &rc, &fspPaths);
   if(pff){
     if(fread(fspCtrl,1,blockSize, pff)<blockSize ||
	strcmp(fspCtrl, FileFmt)){
	idxdscpt=1;	fclose(pff);
	if(!dect)free((void *)rc);
	else return NULL;
	goto Re_Open;
     }
   }
   else {
     if(idxdscpt>0x7ffd)idxdscpt=0;
     if(dect)return NULL;
     Re_Open: if(oldfnm==filenam&&memstr(oldfnm,0, ExtFSP, sizeof(ExtFSP), 0)==NULL){
	    filenam=catstr(oldfnm,ExtFSP,0);
	    goto ropen;
	  }
	skpexit: if(filenam!=oldfnm)free((void *)filenam);
	return NULL;
   }
   lib=fspAlloc();/* mem alloc */
   lib->fpt=pff;
   if(fread(&lib->mode, fspCtrl[fmt_CtrlSize],1,pff)<1){ idxdscpt=3; goto skpexit; }
/*   lib->ver1=fspCtrl[prognamLen+1];
   lib->ver2=fspCtrl[prognamLen+2];
   lib->ver3=fspCtrl[prognamLen+3];
   lib->CtrlSiz=fspCtrl[fmt_CtrlSize];*/
   memcpy(&lib->ver1,fspCtrl+prognamLen+1, 4);
   lib->Num_FCU_Len=getLenght((fsp_dir *)lib);
   struct stat st;
   fstat(pff->_fileno, &st);
   lib->fsz=st.st_size;
//    lib->zcachsiz=pms[pd_param_cnt];
   setZero((fsp_dir *)lib, 0);
   if(oldfnm!=filenam)free((void *)filenam);
   if(!dect)lib->fname=rc;
   idxdscpt=0x7fff;/* clear it for scriptfile */
   if((msg&FastBuf)==0)setbuf(pff, NULL);
   return lib;
 }
 else return NULL;
}

void fspClose(fsp_lib *lib,fsp_lib* (*Compr)(fsp_lib *,const char *,int))
{
if(lib){
    while(lib->cnt_usedir>0)
	pd_close(lib->usedirs[0], 0);
    if(lib->mdf){
      if(Compr){
	unsigned int sz=lib->fsz-lib->useSize;
	if(sz > lib->CmprSiz*1024 &&
		( sz>0xffffff ? sz/(lib->fsz/100) : (sz*100/lib->fsz) ) > lib->cmprPer)
		lib=Compr(lib,NULL, ShowTips /* show "fspRebuild..." */ );
	}
      if(lib->mdf&127)fspTime(0, lib->datebuf); /* 128(OnlyChDir) no chtime */
      dkwrite(lib,blockSize, &lib->mode, lib->CtrlSiz);
    }
    if(lib->fname)free((void *)lib->fname);
    fclose(lib->fpt);
    free(lib);
  }
}
