/*
	Write & edit by Linjianghua(Xempo) 2004-2006, 2008-2015
	Free under LGPL
*/

#include "fsplus.h"

BYTE FileFmt[blockSize]="FSP\0\3\2\4";

/*
prognamTag => prgTagLen : here is 3 + '\0'
version(3) : x.x.x
prgTagLen(3)+1+3 = 7 +1 => blockSize
CtrlSize(1)
*/

const char fspKern[]="FreeStar plus kernel 3.2.4";

int idxdscpt;

#ifndef FSP_SMALL
fsp_lib *LibCmpr;
#endif

void *zalloc(unsigned int sz)
{
void *mem=malloc(sz);
if(mem)memset(mem, 0, sz);
return mem;
}

void appFCT(fsp_dir *dir, const void *dat, int len)
{
	fsp_lib *uxb=dir->lib;
	dkwrite(uxb,uxb->fsz, dat, len);
	free((void *)dat);
	uxb->fsz+=len;
	uxb->useSize+=len;
	dir->selfsize+=len;
}

void freeMAU(MAU *send,int n)
{
int i;
for(i=0;i<n;i++)if(send[i].buf)free(send[i].buf);
}

extern int fseeko64(FILE *__stream, __off64_t __off, int __whence);

void dkwrite(fsp_lib *uxb, dskadr_t pos, const void *dat, unsigned int len)
{
  fseeko64(uxb->fpt,/*pos<1? uxb->FCU_dyw-pos:*/pos, 0);
  fwrite(dat,len,1,uxb->fpt);
}

unsigned int dkread(fsp_lib *uxb, dskadr_t pos, void *dat, unsigned int len, unsigned int cn)
{
  fseeko64(uxb->fpt,pos,0);
  return fread(dat,len,cn,uxb->fpt);
}

void fspTime(time_t ti, unsigned char *ddtt)
{
if(ti==0)time(&ti);
unsigned char *pti=(unsigned char *)&ti;
int L=sizeof(time_t) > FspTmLen ? FspTmLen : sizeof(time_t);
register int i=-1;
while( ++i < L )
	if(i<sizeof(time_t))ddtt[i]=pti[i];
	else ddtt[i]=0;
}

void setFCU(fsp_dir *dir,int step)
{
dir->mdf|=1;
if(dir->lib->sys_Id_done==0)dir->selfnumbs+=step; // #define  isSysIdProc(lib)  lib->sys_Id_done!=0
dir->lib->tolNumb+=step;	dir->lib->mdf|=1;
}

#define	dauSave	8
dskadr_t *getDAU(fsp_dir *dir,BYTE *stat,
		unsigned int *alen, unsigned int *len, int idx)
{
  BYTE *daupos=pFcuDauPos( dir, stat, idx );
  *alen=*(unsigned int *)(daupos+sizeof(dskadr_t));
  *len=*(unsigned int *)( daupos+sizeof(dskadr_t) + sizeof(unsigned int) );
  return (dskadr_t *)daupos;
}

/* #define LenCmp(sendLen,len) (sendLen<len && len-sendLen<200) */

#ifndef _NONE_FAST_PAGE_
static void setZCache(fsp_dir *dir, int Seg,int _numb_cur)
{/* 实际是一个临时记忆 */
if(_numb_cur>0){
  int idx;
  ZeroCache *zero_cache=dir->zcache, *bufptr;
  for(idx=0; idx<dir->zSize; idx++)
	if(zero_cache[idx].pFCT==Seg)return;
  if(dir->zcachesIndex>=dir->zSize)dir->zcachesIndex=0;
   bufptr=zero_cache+dir->zcachesIndex;
   bufptr->pd_adr = dir->own_adr;
   bufptr->pFCT=Seg;
   bufptr->NumbForZero=_numb_cur;
   dir->zcachesIndex++;
 }
}
#endif

void FailSeekMsg(int msg)
{
switch(msg&(255-15)){
case FSP_BROW :
case FSP_REN :
case FSP_READ :
case FSP_DEL :
case FSP_FCU_POS : idxdscpt=msg>510 ? NoDir_6 : NoNumb_4;
}
}

BYTE *seekFCU(fsp_dir *dir,int nmb, const void *dirnam,int _Msg)
{
if(dir){
int i, j, len, clen, FCU_Count, dau,
msg=_Msg&(1024-1),
info=msg&(256-1 -15), /* <15 is mode(<4bits) */
pure_org_Msg=msg&( 1024-1 - 15 ),
 cn_dacu=0;
fsp_lib *uxb=dir->lib;
BOOL zero, superWay=(uxb->sys_Id_done ||(dir->mdf&NEW_DIR));
FCU_PAT *vStat, *dirloop;
BYTE *FCT_buf=NULL, *pStat,  *pUnit,
/* ----- numb stat style ---- */
 Tag, mode;
 int numb,
/* ----- stylemember ------ */
 NUMB, Numb_Cnt, dflen,
  numbcnt;
dskadr_t *ptr, Seg, csbadr;
#ifndef _NONE_FAST_PAGE_
int  pg_separator, pg_cnt;
ZeroCache *zero_cache;
#endif

if( noWrite(dir->mode) && (dir->mdf&NEW_DIR)==0 )
	switch(info){
	case FSP_DEL :
	case FSP_REN :
	case FSP_WRITE	:
/*	case FSP_BROW	:*/
	case FSP_RESCUE	: idxdscpt=(dir->mode&FSP_OEM) ? OEM_20 : NoWrite_15;
			return NULL;
		}

uxb->FCU_dyw=0;/* init every call */
idxdscpt=0x7fff; /* no-error code */
if(uxb->sys_Id_done){
	dir=(fsp_dir *)uxb;
	dirloop=dGetFCU(dir);
	vStat=sys_nGetFCU(uxb);
	}
else {
	dirloop=dGetFCU(dir);
	vStat= msg>510? dirloop : nGetFCU(dir);
}

if(info!=FSP_FCU_BLANK){
	Seg=vStat->first_FCT;
	if(Seg==0&&isNormDir(dir))dir->mdf|=FIRST_FCT;
	}
else Seg=vStat->current_FCT;

FCU_Count=vStat->FCU_Count;

if(msg>510){
	zero=False;
	clen=Dir_FCU_Len;
	}
else{
     if(uxb->sys_Id_done){
	clen=FCU_NumPos+sizeof(DAU);  dau=1;
	zero=True;
	}
     else {
	clen=dir->Num_FCU_Len;     dau=dir->DAUC;
	zero=isZero(dir->Format);
	}
     if(zero){	Numb_Cnt=0;	numbcnt=0;
#ifndef _NONE_FAST_PAGE_
	if(pure_org_Msg!=NUMB_FCU_BLANK&&uxb->sys_Id_done==False){/* read page-buff */
	  zero_cache=dir->zcache;
	  NUMB=0x7fffffff;

	  for(j=-1,i=dir->zSize-1; i>-1; i--)
	    if(zero_cache[i].pFCT>0 && zero_cache[i].pd_adr==dir->own_adr ){
		numb=nmb - zero_cache[i].NumbForZero;
		if(numb>-1 && NUMB>numb){ NUMB=numb; j=i; }
		}
	  if(j>-1){
	     Seg=zero_cache[j].pFCT;
	     Numb_Cnt=zero_cache[j].NumbForZero;
	  }
	  pg_separator=(nmb-Numb_Cnt)/(dir->zSize+1);  /* fit to redure scndsk */
	  if(pg_separator==0)pg_separator=1;
	  pg_cnt=0;
	}
#endif
	uxb->FCT_calc=Numb_Cnt/FCU_Count;
	}
     else {
#ifndef FSP_SMALL
	if(LibCmpr==uxb)Seg=vStat->current_FCT;/* for rebuild */
#endif
	}
     if(pure_org_Msg!=NUMB_FCU_BLANK)dir->NumbForZero=nmb;
     else dir->pos_numb_FCT=Seg;
}

if(pure_org_Msg==NUMB_LAST)pUnit=NULL;
else if((pUnit=(BYTE *)zalloc(clen))==NULL)goto failmem;
len=FCU_Count*clen+sizeof(dskadr_t);
if(Seg==0){
    if(info==FSP_WRITE){
	vStat->first_FCT=uxb->fsz;
#ifndef FSP_SMALL
	if(uxb==LibCmpr)vStat->current_FCT=uxb->fsz;
#endif
	uxb->LNKDWORD=uxb->fsz;
	return pUnit;
	}
    else {
	idxdscpt=msg>510? NoDir_6:NoNumb_4;
	goto rt1;
	}
}

if((FCT_buf=(BYTE *)malloc(len))==NULL){ 
 failmem: idxdscpt=FAIL_MEM_12; goto rt1;
}

ptr=(dskadr_t *)(FCT_buf+len-sizeof(dskadr_t));
while( Seg>0 ){
 if(dkread(uxb,Seg,FCT_buf,len,1)<1){	/* file error */
   idxdscpt=ErrScnFile_5;	break;
	}
/* #ifndef FSP_SMALL no set here, for search */
 if(info==FSP_FCU_BLANK){
	vStat->current_FCT=*ptr; 
	rt1: free(pUnit);
	return FCT_buf;
 }
/*#endif*/

 if(zero){
	NUMB = Numb_Cnt + FCU_Count;
#ifndef _NONE_FAST_PAGE_
	if(uxb->sys_Id_done==False){
		pg_cnt+=FCU_Count;
		if(pg_cnt>=pg_separator){
			setZCache(dir,Seg,Numb_Cnt);
			pg_cnt=0;
			}
	}
#endif
	if(NUMB<=nmb){
	  if(*ptr<1)csbadr=Seg+len-sizeof(dskadr_t);
	  Numb_Cnt=NUMB;
	  goto loop;
	  }
  }
#ifndef FSP_SMALL
  else if(LibCmpr==uxb)vStat->current_FCT=Seg; /* for rebuild */
#endif

  for(i=0,pStat=FCT_buf, csbadr=Seg; i<FCU_Count; i++,csbadr+=clen,pStat+=clen){
    Tag=*pStat;
    numb=msg>510? strcmp((char *)dirnam, /*((DirFCU *)pStat)->name*/ (char *)(pStat+FCU_NumPos)):
    (zero? Numb_Cnt++ : *(int *)(pStat+FCU_NumPos) );
    switch(Tag){
    case 1 :
      if(pure_org_Msg==NUMB_LAST){/* only Zero, but here not limit, as when input(con) ought to denied */
	if(++numbcnt>=dir->selfnumbs){/* sucess */
		dir->NumbForZero=Numb_Cnt;
		free(FCT_buf);
		return NULL;
		}
	continue;
	}
      if(nmb==numb){
	mode=pStat[1];/* bit(Unix mode): 0=read, 1=write, 2=hide, 3=OEM */
	switch(info){/* find it */
	case FSP_WRITE : if(superWay==False){
				if( mode&FSP_OEM ){
				  _OEM_: idxdscpt=OEM_20;
				  goto outloop;
				}
				if( (mode&FSP_MW)==0 ){
				  _no_write_: idxdscpt=NoWrite_15;
				  goto outloop;
					}
			}
		if(msg>510)idxdscpt=Dir_Exist9; /* dir */
		else { idxdscpt=OverWriteNum_14;	 pStat[0]=0;/* deffernec NumCopy */ }
		goto _get_dat_;
	case FSP_DEL : /*if(superWay==False){
				if( mode&FSP_OEM )goto _OEM_;
				if( (mode&FSP_MW)==0  )goto _no_write_;
			}
		goto _get_dat_;*/
	case FSP_REN : if(superWay==False ){
			if(mode&FSP_OEM)goto _OEM_;
			if((mode&FSP_MW)==0)goto _no_write_;
			}
			goto _get_dat_;
	case FSP_READ : if(superWay==False && (mode&FSP_MR)==0 ){
				idxdscpt=NoRead_16;
				goto outloop;
			}
	case FSP_BROW :	_get_dat_: memcpy(pUnit,pStat,clen);
	case FSP_FCU_POS :
	 skp1:  uxb->FCU_dyw=csbadr;
	   goto outloop;
		}/* find it */
	   }
	break;/* useful */
    case 0 : 	/* follow is dat->=0 */
	switch(info){
	case FSP_WRITE :
		if(zero){
			if(nmb==numb)goto _get_dat_;
			}
	        else {
	#ifndef FSP_SMALL
			if(LibCmpr==uxb)goto skp1;
	#endif
			if(uxb->FCU_dyw==0)uxb->FCU_dyw=csbadr;
			}
		break;
	case FSP_READ : if(zero&&numb>=nmb)goto outloop;
		}
	break;	/* msg=0; only init */
     case 2 : 
     case 3 : /* erase */
	switch(info){/* unuseful,  !!zero have tried OPM */
	case FSP_WRITE : 
	  if(zero){
		if(numb==nmb)goto _get_dat_;
		}
	  else {
		BYTE dtbu[8];
		fspTime(0, dtbu);
	      if( *(int *)(dtbu+2)-*(int *)(pStat+FCU_TimePos+2)>15 || /* deleted data can be reserve 15 day */
		Tag==3 /* erase tag */){
		if(msg>510){
			if(uxb->FCU_dyw==0){
			     memcpy(pUnit,pStat,clen);
			     uxb->FCU_dyw=csbadr; /* unit-pos which will write */
			}
		}
		else {
			unsigned int alen, len;
			int cnt_df=0, df, b=0, c;
			MAU *send=(MAU *)dirnam;
			for(c=0; c<dau; c++){
			  getDAU(dir,pStat,&alen,&len,c);
			  if(send[c].len<=alen){
				df=alen-send[c].len;
				if(df>2048&&send[c].len<3000)goto noRe;
				b++; cnt_df+=df;
				}
			 }
			if(b>cn_dacu){
				cn_dacu=b;
				setval:uxb->FCU_dyw=csbadr;
				dflen=cnt_df;
				memcpy(pUnit,pStat,clen);
				}
			else if( (b>0 && b==cn_dacu && cnt_df<dflen) ||
				(uxb->FCU_dyw==0 && dau>1) )goto setval;
		}
	   }
	}
	noRe:break;
#ifndef FSP_SMALL
	case FSP_RESCUE : 		goto _get_dat_;
#endif
/*	case NUMB_READ : goto outloop; perhan many same name or nmb data is unuse*/
	}/* sw >1 */
    }/* end sw-Tag */
}/* for-loop */
loop: uxb->FCT_calc++;	Seg=*ptr;
}/* while-loop */
outloop: free(FCT_buf);
if(zero &&
	info!=FSP_WRITE && pure_org_Msg!=NUMB_FCU_BLANK )dir->NumbForZero=Numb_Cnt-1;
if(uxb->FCU_dyw==0){
	if(info==FSP_WRITE){
		if(idxdscpt>0x7ffd)uxb->LNKDWORD=csbadr;
	}
	else {
		free(pUnit);
		if(idxdscpt>0x7ffd)FailSeekMsg(msg);
		return NULL;
	}
}
return pUnit;
}
idxdscpt=NoBuff_2;
return NULL;
}


char *readDAU(fsp_dir *dir, BYTE *unit, MAU *send, int idx)
{
if(send && unit/* &&*unit==1, reuse-func in future */){
  unsigned int alen, len, cn;
  dskadr_t *padr=getDAU(dir,unit,&alen,&len,idx);
  if(len<1)send->buf=NULL;
  else {
	fsp_lib *lib=dir->lib;
	send->buf=(char *)malloc( len + 2 );
	if(send->buf==NULL){ idxdscpt=FAIL_MEM_12; return NULL; }
	if(len<=dauSave&&alen<=dauSave){
		memcpy(send->buf, padr, len);
		cn=len;
	}
	else {
		cn=dkread(lib, *padr, send->buf,1,len);
		if(cn<len)idxdscpt=I_ErrStru;
	}
	send->len=cn;
	send->alen=alen;
	send->buf[cn]=0;  /* this time buf point to change */
   }
   return send->buf;
 }
return NULL;
}

int readFCU(fsp_dir *dir,BYTE *stat, MAU *send, int cnt)
{
memset(send, 0, sizeof(MAU)*cnt );
if(stat&&cnt>0){
  int i;
  if(cnt>dir->DAUC)cnt=dir->DAUC;
  for(i=0; i<cnt; i++)
	readDAU(dir, stat, send+i, i);
}
return cnt;
}

BYTE *num_read(fsp_dir *dir,int numb,MAU *send, int n)
{
BYTE *stat=seekFCU(dir,numb,NULL, NUMB_READ);
readFCU(dir,stat,send,n);
return stat;
}

void writeDAU(fsp_dir *dir,BYTE *unit,MAU *mau, int idx)
{/* write one DAU */
fsp_lib *uxb=dir->lib;
BYTE *daupos=unit+(uxb->sys_Id_done ? FCU_NumPos : FCU_DAUPos(dir,idx));
if(mau&&mau->buf){/* type: Po_Int must take in kernel */
   unsigned int alen, len,  pre_len;
   dskadr_t *padr=getDAU(dir, unit, &alen, &len, idx);
   pre_len= mau->alen < mau->len ? mau->len : mau->alen;
   setLenDAU(daupos, mau->len); /* set DAU len */
   if(mau->len<=dauSave&&alen<=dauSave){
	memcpy(daupos, mau->buf, mau->len);
	setAlenDAU(daupos, mau->len); /* set DAU alen  */
	}
   else {
/* if(len>0&&send.len==0)send.len=1; here can proc del dau, !!no write(,,,statlen) can rem dau */
	if( idxdscpt==OverWriteNum_14/*||isZero(pdp->Format)*/){
		dir->selfsize-=len;
		uxb->useSize-=len;
	} /* overwrite */
	if( alen < mau->len ){
		setAlenDAU(daupos, pre_len);/* set DAU alen */
		*padr=uxb->fsz;
		uxb->fsz+=pre_len;
		char *buff=(char *)zalloc(pre_len);
		memcpy(buff,mau->buf,mau->len);
		dkwrite(uxb, *padr, buff, pre_len);
		free(buff);
	}
	else dkwrite(uxb, *padr,mau->buf,mau->len);
	dir->selfsize+=mau->len; /* selfsize is tab data's size,not disksize, deffenct uxb->fsz */
	uxb->useSize += mau->len;
       }
  }
else setLenDAU(daupos, 0); /* set DAU len=0 */
}

void pdSave(fsp_dir *dir)
{
     if(dir->mdf&NEW_DIR)dkwrite(dir->lib, dir->Own_FCU_Addr, &dir->tag, Dir_FCU_Len);
     else dkwrite(dir->lib, dir->Own_FCU_Addr+D_DATEPOS, dir->datebuf, FspTmLen);
     dkwrite(dir->lib, dir->own_adr, &dir->cur_numb_FCT, dir->savelen);
     dir->mdf&=NEW_DIR|FreeDirAlloc; // reserve NEW_DIR for seekFCU,   FreeDirAlloc(64) for free
}

BYTE *writeInit(fsp_dir *dir,int numb,MAU *send,int n)
{
  int i;
  BYTE *stat;
  MAU *mau=send;
  for(i=0; i<n&&mau; i++,mau++){
	if(mau->buf==NULL)mau->len=0;
	else if(mau->len==0)mau->len=strlen(mau->buf);
	if(mau->len>FspLimit)mau->len=FspLimit;
	}
  stat=seekFCU(dir,numb,send, NUMB_WRITE );
  if(stat && dir->lib->sys_Id_done==False && isZero(dir->Format)==False )*((int *)(stat+FCU_NumPos))=numb;
  return stat;
}

void creatFCT(fsp_dir *dir, int len, int n)
{
fsp_lib *uxb=dir->lib;
dkwrite(uxb,uxb->LNKDWORD,&uxb->fsz,sizeof(dskadr_t));
uxb->FCU_dyw=uxb->fsz;
BYTE *dat=(BYTE *)zalloc(len);
if(dat){
	dat[len-2]=n;
	appFCT(dir, dat, len);
	}
}

void addFCT(fsp_dir *dir,BYTE *stat)
{
 fsp_lib *uxb=dir->lib;
 int stlen, c_n_unit;
 if(uxb->sys_Id_done){
	stlen=FCU_NumPos+sizeof(DAU);
	c_n_unit=SYS_ID_BLOCK;
	}
 else {
	stlen=dir->Num_FCU_Len;
	c_n_unit=dir->Num_FCUs_Block;
 }

if(uxb->FCU_dyw==0){
	int i, len=stlen * c_n_unit+sizeof(dskadr_t);
	if(uxb->sys_Id_done || isZero(dir->Format)){
#define	_Numb_		(dir->NumbForZero+1)
	int cn=_Numb_/c_n_unit+(_Numb_%c_n_unit? 1:0)-uxb->FCT_calc;
#undef	_Numb_
	for(i=0;i<cn;i++){
		creatFCT(dir,len,0);
		uxb->LNKDWORD=uxb->fsz-sizeof(dskadr_t);
	}
	cn=dir->NumbForZero%c_n_unit;
	uxb->FCU_dyw+=stlen*cn;
#ifndef _NONE_FAST_PAGE_
	if(uxb->sys_Id_done==False)
		setZCache(dir, uxb->FCU_dyw-cn*stlen, dir->NumbForZero - cn);
#endif
    	}
	else creatFCT(dir,len,0);
}
}

void writeFCU(fsp_dir *dir, BYTE *stat, time_t tm)
{
   fsp_lib *uxb=dir->lib;
   setFCU(dir, idxdscpt==OverWriteNum_14 ? 0:1);
/* idxdscpt is extern, it would be change by other func, such as gethb */
   if(*stat!=1){ /* 1 is copy msg */
	fspTime(tm, FCU_GetDate(stat ) );
	*stat=1;
	}
    dkwrite(uxb,uxb->FCU_dyw, stat,
	uxb->sys_Id_done ? FCU_NumPos+sizeof(DAU) : dir->Num_FCU_Len);
    if(dir->mdf&FIRST_FCT)pdSave(dir);
}

BYTE *num_write(fsp_dir *dir,int numb,MAU *send, int nu)
{
  fsp_lib *lib=dir->lib;
  BYTE *stat=writeInit(dir, numb,send, nu);
  if(stat){
	BOOL len=False;
	int i;
	stat[1]=1|2;
	addFCT(dir, stat);
	if(lib->sys_Id_done)nu=1;
	else if(nu > dir->DAUC)nu=dir->DAUC;
	for(i=0; i<nu; i++){
		writeDAU(dir,stat,send+i, i);
		if(send[i].len>0)len=True;
		}
	if(len)writeFCU(dir, stat, 0);
	free(stat);
	}
  lib->sys_Id_done=False;
  return stat;
}


/* -------------------------------------------------------------------------------------------*/

int lastNumb(fsp_dir *dir) // zera append
{
seekFCU(dir,0/* must 0 for count */,NULL,NUMB_LAST);
idxdscpt=0x7fff;	/* perhan idxdscpt==NoNumb_4 no csb*/
return dir->NumbForZero;
}

void chDirFCU(fsp_dir *dir, BYTE *fcu, dskadr_t pos, int step)
{
  int len;
  getSize(dir,fcu, len)
  len*=step;
  dir->selfsize+=len;
  dir->lib->useSize+=len;
  fspTime(0, FCU_GetDate(fcu ) );
  setFCU(dir,step);
  dkwrite(dir->lib,pos,fcu,1);
  if(isNormDir(dir) && isBase(dir->Format) ){
//	SDBCTlinkor *statlnk;
	int ln=dir->Num_FCUs_Block*dir->Num_FCU_Len;
	BYTE *statlnk=(BYTE *)(dir->curFCU+ln);
	dir->cur_dcu->use_cnt--;	
//	statlnk->cnt--;
	NCTlinkor_cnt(statlnk)--;
	dkwrite(dir->lib,dir->posFCU,dir->curFCU, ln+NCTlinkor_size());
	free(dir->curFCU);
	}
}

BOOL num_del(fsp_dir *dir,int nmb)
{
  BYTE *unit;
#ifdef			_Simple_Base_ 
  if(dir->Format&SimpleBase)unit=SDBseek(dir,nmb,NUMB_DEL);
  else
#endif
  unit=seekFCU(dir,nmb,NULL,NUMB_DEL);
  if(unit){
	*unit=2;
	chDirFCU(dir,unit,dir->lib->FCU_dyw,-1);
	free(unit);
	return True;
	}
  return False;
}

BOOL num_ren(fsp_dir *dir,int oldnmb,int newnmb)
{
BYTE *unit;
if(isZero(dir->Format))idxdscpt=ZeroRen_17;
else if((unit=seekFCU(dir,newnmb,NULL,NUMB_FCU_POS))!=NULL)
	{ idxdscpt=DupNumb_24; free(unit); }
    else {
      unit=seekFCU(dir,oldnmb,NULL,NUMB_REN);
      if(unit){
	dkwrite(dir->lib,dir->lib->FCU_dyw+FCU_NumPos,&newnmb, sizeof(int));
	free(unit);
	return True;
    }
    else if(idxdscpt==0x7fff)idxdscpt=NoNumb_4;
  }
  return False;
}
