/*
	xempo write in 4-2014
	Free under LGPL 2014, 2015
*/

#include <qgroupbox.h>
#include <qcheckbox.h>
#include <qcombobox.h>
#include <qdatetimeedit.h>
#include <qlineedit.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qtextcodec.h>
#include <qtextbrowser.h>
#include <qpainter.h>
#include <qfontmetrics.h>
#include <qaccel.h>
#include "combo.h"
#include "searchmodify.h"
#include "infowidget.h"
#include "inputdlg.h"
#include "simpleimage.h"
#include "fspcon.h"
#include "stdfun.h"
#include "../rtdata/en/target/filesor.h"
#include "../rtdata/en/target/smwdg.h"
#include "fileatt.h"
#include "copypanel.h"
#include "rebuild.h"

enum SM_Event {
	Event_Error=65201,
	Event_AddItem=65204,
	virtual_notify=65205
	};

#define __fromUnicode(s, c) _setCodec(c)->fromUnicode(s)

#define  optListLen  220
#define  LeftWide  54

extern int buttonMsg;

static const char __div[]="\n", *sm_dtfmt, __listSet[]="listSet";
const char search_modify[]="SearchModify";

QStringList smLogList;

unsigned int __uid, __gid,	early_dt, late_dt;

const char slot_find[]=SLOT(find()), slot_find2[]=SLOT(find2()),// find & replace
	slot_stop[]=SLOT(stop());

void SearchModify::popRightMenu(LVItem *it)
{
if(sm_cnt){
	ActMenu   rightMenu(this);
	QPopupMenu openMenu(this);
	rightMenu.setFont(font());
	if(it){
	  const char *fn=it->fnam;
	  selAsSrcAct->addTo(&rightMenu);
	  selAddAct->addTo(&rightMenu);
	  rightMenu.insertSeparator();
	  rightMenu.insertMenu(dirImg, openPath, this, SLOT(PZpath()), Key_F11 );
	  rightMenu.insertMenu(-1, exefile, this, slot_open, 0);
	  if(creatOpenMenu(openMenu, filesor, fn)){
		openMenu.setFont(font());
		rightMenu.insertItem(QString::fromUtf8(opensChs), &openMenu);
		}
	  renAct->addTo(&rightMenu);
	  struct stat64 st;
	  stat64(fn, &st);
	  rightMenu.insertSeparator();
	  if( S_ISDIR(st.st_mode) ){
		dirSumAct->addTo(&rightMenu);
		if(selAsSrc.count()&&isWritable(uId, gId, &st)&&isExecable(uId,gId, &st) ){
			cp2dirAct->addTo(&rightMenu);
			mv2dirAct->addTo(&rightMenu);
			}
		}
	  else if( isReadable(uId, gId, &st) ){
		proEditAct->addTo(&rightMenu);
		fspConAct->addTo(&rightMenu);
		sImageAct->addTo(&rightMenu);
		rightMenu.insertSeparator();
		}
	  attribAct->addTo(&rightMenu);
	  rightMenu.insertSeparator();
	  delAct->addTo(&rightMenu);
	  rightMenu.insertSeparator();
	  vdelAct->addTo(&rightMenu);
	}
	selAllAct->addTo(&rightMenu);
	rightMenu.exec(QCursor::pos());
}
}

SearchModify::SearchModify(QWidget* parent)
    : QMainWindow(parent, search_modify, WType_TopLevel|WDestructiveClose ),
	smThread(-1), runSearch(false),
	fsels(__AppenAlone),	operalst(__AppenAlone),
	filesor((Filesan *)parent),	operaListTag(false),
	_Params(__params), wheel_SM(0), // 	_vList(NULL),
	fntSz(baseHeight), listSetMsg(false), freqPix(freqIco),
	SMpms((struct findparams *)zalloc(sizeof(struct findparams))),
	orgw(0), orgb(0), waitMsg(false), cpEvent(false), startMsg(false),
	pfdat(NULL), sm_preCnt(0), deleting(false),
	kwCodec(sm_kwCodeComboIdx), pathCodec(sm_pathCodeComboIdx)
{
   _smwdg_=charsFromFSP(5);
}

#define  hg_ref  508
#define  hgref  554
void SearchModify::exe()
{
    setFont(filesor->font());
    fmtr=new QFontMetrics(font());
    resize(760*fntSz/_baseH_, hgref*fntSz/_baseH_);
    tb=new QToolBar(search_modify, this, Qt::DockBottom);
    tb->setMovingEnabled(false);
    tabs=new QTabWidget(this);
    QWidget *optsTab=new QWidget(tabs);
    setCentralWidget(tabs);
    addTA(this, tb, closeImg, exitFndwdg, NULL, SLOT(smClose()), CTRL+Key_X, false, false);
    tb->addSeparator();
    smLogListAct=addTA(this, tb, findLogImg, smLogListChs, NULL, SLOT(smLog()), Key_F9, false, false);
    smLogListAct->setEnabled(smLogList.count());
    saveResultAct=addTA(this, tb, saveImg, saveResult, NULL, SLOT(saveResult()), 0, false, false );
    saveResultAct->setEnabled(false);
    tb->addSeparator();
    addTA(this, tb, helpImg, helpChs, NULL, SLOT(hlp()), Key_F1, false, false);
    sbar=new StatusPanel(tb, sbar_SearchModify);
    painter=new QPainter(sbar);
    findAct=addTA(this, tb, findImg, findChs, NULL, slot_find, CTRL+Key_F, false, false);
    replAct=addTA(this, tb, searchModifyImg, replActChs, NULL, slot_find2, CTRL+Key_R, false, false);
    searchCutAct=addTA(this, tb, searchCutImg, searchCut, NULL, SLOT(smCut()), CTRL+Key_C, false, false );
    operaListAct=addTA(this, tb, operaListImg, operaListChs, NULL, SLOT(OL()), Key_F5, true, false);
    operaListAct->setEnabled(false);
    tb->addSeparator();

    stopAct=addTA(this, tb, stopImg, stopChs, NULL, slot_stop, ALT+Key_S, false, false);
    stopAct->setEnabled(false);
    tb->setStretchableWidget(sbar);

    MAU mau;
    numbRead(fspRoot, sm_colOptId, &mau, 1, true);
    smColOpt=mau.buf;
    if(numbRead(fspRoot, sm_datasId, &mau,1, false)>-1){
	int *ipt=(int *)mau.buf;
	__uid=ipt[0];		__gid=ipt[1];
	early_dt=ipt[2];	late_dt=ipt[3];
	}
    else { __uid=uId; __gid=gId; }
    timChkChs=_smwdg_+Int_tmChksChs;
    sizChkChs=_smwdg_+Int_szChksChs;

    tabs->addTab(optsTab,*pixmapLoad(genSetImg), QString::fromUtf8(findSetChs));
    _vList=(ListContent *)creatFileList(tabs, (void *)FindListChs, smColOpt, smUseCols, 2);
    memcpy(colsbak, smColOpt, colOptCnt*2);
    tabs->addTab(_vList, QString::fromUtf8(findResultChs));
    listSet=new QWidget(tabs, __listSet);
    tabs->addTab(listSet, *pixmapLoad(listSetImg), QString::fromUtf8(listSetChs));
    lmtSiz=new QLabel(QString::fromUtf8(sizLmt), listSet);
    listSetInit(listSet, &optList, scaleRect(54, 26, optListLen, 270), &upBtn, &downBtn, smColOpt);
    orgStyleBtn=new QPushButton(QString::fromUtf8(orgStyle), listSet);
    sm_dtfmt=sm_dtfmtlst.lstIndex(sm_dtfmtCombIdx);
    dtfmtLab=new QLabel(QString::fromUtf8(dtfmtChs)+QDateTime::currentDateTime().toString(sm_dtfmt), listSet);
    dtfmtCombo=creatCombo( false, listSet, "smdtfmt", p_sm_dtfmtlst, -1 );   
    grapCombo=creatCombo( false, listSet, "grapLmt", p_graplmtlst, -1 );
    grapShowChk=new QCheckBox(QString::fromUtf8(showGrap), listSet);

//    initFndwdg();
static const char *slot_szBtns[]={ SLOT(Sz1()), SLOT(Sz2()),SLOT(Sz3()) },
 *slot_tmBtns[]={ SLOT(T1()),SLOT(T2()),SLOT(T3()) };
    int i, cn;
    pathGroup = new QGroupBox( QString::fromUtf8( pthChs ), optsTab );
    pathCombo = creatCombo(true, pathGroup, "smpath", p_smpath, -1);
    pathCombo->setCurrentText( filesor->getDirNam() ? tranText(strCodec, filesor->getDirNam()) : (pathStr.isEmpty() ? pathCombo->currentText() : pathStr) );

    filterCombo = creatCombo(true, pathGroup, filterCombChs, p_smfilter, -1);

//    connect(filterCombo->lineEdit(), SIGNAL(lostFocus()), this, SLOT(elost()) );
    if(sm_filterNull){
	filterNull=true;
	filterCombo->insertItem(*pixmapLoad(smfilterImg), 0);
	filterCombo->setCurrentItem(0);
	}
    else if( filterStr.isEmpty() ){
	if(filterNull=filterCombo->currentText().isEmpty())
		filterCombo->insertItem( *pixmapLoad(smfilterImg) );
	}
	else filterCombo->setCurrentText( filterStr );

    subChk = new QCheckBox( QString::fromUtf8( subChs ), pathGroup );

    pathCaseChk = new QCheckBox(QString::fromUtf8( smCaseChs ), pathGroup );
    codeLab1=new QLabel(pathGroup);
    pathCodeCombo=new QComboBox( false, pathGroup, "pthCode" );

    keywordGroup = new QGroupBox( QString::fromUtf8( kwChs ), optsTab );
    TDSChk=new QCheckBox(QString::fromUtf8(useTDS), keywordGroup);
    connect(TDSChk, clickSig, this, SLOT(TDS()));
    QToolTip::add( TDSChk, QString::fromUtf8(useTDSTip) );
    TDSChk->setChecked(_Params[27]);

    kwfind = new QLabel( QString::fromUtf8( _smwdg_[_Params[27] ? Int_TDScript : Int_findChs]), keywordGroup );
    kwfind->setPaletteForegroundColor(_Params[27] ? 0x000090 : 0x000000);
    kwfind->setAlignment( int( QLabel::AlignCenter ) );
    keywordCombo = creatCombo( true, keywordGroup, "keyword", p_kwFindlst, -1 );
    keywordCombo->setCurrentText(kwFind.isEmpty() ? keywordCombo->currentText() : kwFind );

    kwrepl = new QLabel( QString::fromUtf8( replChs ), keywordGroup );
    kwrepl->setAlignment( int( QLabel::AlignCenter ) );

    replaceCombo = creatCombo( true, keywordGroup, replCombChs,  p_kwRepllst, -1);
    replaceCombo->setCurrentText(kwRepl.isEmpty() ? replaceCombo->currentText() : kwRepl );
    kwCaseChk = new QCheckBox(QString::fromUtf8( smCaseChs ), keywordGroup );
    kwCaseChk->setChecked(sm_runCase);
    connect(kwCaseChk, clickSig, this, SLOT(findCS()));

    kwWordChk= new QCheckBox(QString::fromUtf8( findWordChs ), keywordGroup );
    kwWordChk->setChecked(sm_wholeWord);
    connect(kwWordChk, clickSig, this, SLOT(findWord()));

    resetChk= new QCheckBox(QString::fromUtf8( resetChs ), keywordGroup );
    resetChk->setChecked(sm_reset);
    QToolTip::add( resetChk, QString::fromUtf8(resetTip) );
    connect(resetChk, clickSig, this, SLOT(reset()));

    bakupChk= new QCheckBox(QString::fromUtf8( bakupChs ), keywordGroup );
    bakupChk->setChecked(sm_bakup);
//    connect(bakupChk, clickSig, this, SLOT(reset()));
    binChk = new QCheckBox(QString::fromUtf8( binModeChs ), keywordGroup );
    binChk->setChecked(sm_binMode);
    connect(binChk, clickSig, this, SLOT(findBM()) );
    QToolTip::add( binChk, QString::fromUtf8(BMTip) );
 
    codeLab2=new QLabel(keywordGroup);
    const QPixmap *pix=pixmapLoad(codecImg);
    codeLab1->setPixmap(*pix);
    codeLab2->setPixmap(*pix);

    kwCodecCombo=new QComboBox(false, keywordGroup, "kwCode");
    QToolTip::add( kwCodecCombo, QString::fromUtf8(codeToFword) );
    codecComb(kwCodecCombo, kwCodec);
//____________________________________________________________________

    fileGroup = new QGroupBox(QString::fromUtf8( fAttrChs ), optsTab );
    for(i=0; i<3; i++){
	chk[i]= new QCheckBox( QString::fromUtf8(sizChkChs[i]), fileGroup );
	connect(chk[i], clickSig, this, slot_szBtns[i]);
	}
    if(sm_szChk)chk[sm_szChk-1]->setChecked(true);

    fsizeCombo0 = creatCombo( true, fileGroup, "Small", p_fsize0lst, -1 );
    fsizeCombo0->setEnabled(sm_szChk>0&&sm_szChk<3);
    fsizeCombo1 =creatCombo( true, fileGroup, "Large", p_fsize1lst, -1);
    fsizeCombo1->setEnabled(sm_szChk>1);

    fuser=new QCheckBox(QString::fromUtf8(fuserChs), fileGroup );
    fuser->setChecked(sm_user);
    connect(fuser, clickSig, this, SLOT(fuser()));

    fgroup = new QCheckBox(QString::fromUtf8(fgroupChs), fileGroup);
    fgroup->setChecked(sm_group);
    connect(fgroup, clickSig, this, SLOT(fgroup()));

    userCombo = creatCombo( false, fileGroup, "usr", usrList , userImg);
    userCombo->setEnabled(sm_user);
    cn=usrList->count();
    for(i=0; i<cn&&usrIDs[i]!=__uid; i++);
    userCombo->setCurrentItem( cn-1-i );
    groupCombo = creatCombo( false, fileGroup, "group",  grpList, groupImg );
    groupCombo->setEnabled(sm_group);
    cn=grpList->count();
    for(i=0; i<cn&&groupIDs[i]!=__gid; i++);
    groupCombo->setCurrentItem(cn-1-i);
//____________________________________________________
    timeGroup= new QGroupBox( QString::fromUtf8( timeChs ), optsTab );
    for(i=0; i<3; i++){
	tmChk[i]= new QCheckBox( QString::fromUtf8(timChkChs[i]), timeGroup );
	connect(tmChk[i], clickSig, this, slot_tmBtns[i]);
	}
    if(sm_tmChk)tmChk[sm_tmChk-1]->setChecked(true);
    QDateTime dt;
    dt.setTime_t(early_dt);
    earlyDateTime = new QDateTimeEdit( early_dt ? dt : QDateTime::currentDateTime(), timeGroup );
    earlyDateTime->setEnabled(sm_tmChk>0&&sm_tmChk<3);

    dt.setTime_t(late_dt);
    lateDateTime = new QDateTimeEdit( late_dt ? dt : QDateTime::currentDateTime(), timeGroup );
    lateDateTime->setEnabled(sm_tmChk>1);

    grapCombo->setEnabled(sm_grapShow);
    grapCombo->setCurrentItem(sm_grapSizIdx);
    grapSizLmt=atoi(grapCombo->currentText());
    setIcon(*pixmapLoad(diskfindImg));
//    setRightJustification(true); // 确保拉伸    
    show();
    // sizeAdjust();
    setCaption( QString::fromUtf8( SearchModifyChs ) );
    connect(tabs, SIGNAL(currentChanged(QWidget *)), this, SLOT(chTab()));
    connect(orgStyleBtn, clickSig, this, SLOT(orgStyle()) );
    dtfmtCombo->setCurrentItem( (dtfmtCombo->count()-1) - sm_dtfmtCombIdx);
    connect(dtfmtCombo, sigactIdx, this, SLOT(smDtFmt()));

    grapShowChk->setChecked(sm_grapShow);
    connect(grapShowChk, SIGNAL(clicked()), this, SLOT(grapChk()) );

    connect(grapCombo, sigactIdx, this, SLOT(selSiz()));
    pathCombo->lineEdit()->selectAll();
    QToolTip::add( filterCombo, QString::fromUtf8(filterChs) );
    subChk->setChecked(sm_includeSub);
    connect(subChk, clickSig, this, SLOT(sub()));
    pathCaseChk->setChecked(sm_pathCase);
    connect(pathCaseChk, clickSig, this, SLOT(pathCS()));
    QToolTip::add( pathCodeCombo, QString::fromUtf8(codeToFnam) );
    codecComb(pathCodeCombo, pathCodec);

//_____________________________________________________________

    cn=sbar->height();
    fntBPos=(cn*2+fntSz) / 4; // - baseHeight/4 "base line"
    pixBPos=(cn-22)/2;
    selAsSrcAct=addTA(this, NULL, selectImg, _Spc, selectChs, slot_asSrc, CTRL+Key_S, false, false);
    selAddAct=addTA(this, NULL, selectAddImg, _Spc, fndSelAddChs, slot_addSrc, Key_F3, false, false);
    proEditAct=addTA(this, NULL, proEditImg, _Spc, proEditChs, slot_proedit, Key_F6, false, false);
    dirSumAct=addTA(this, NULL, dirSummImg, _Spc, dirSumm, slot_dsum, CTRL+Key_F4, false, false );
    cp2dirAct=addTA(this, NULL, cp2dirImg, _Spc, cp2dirChs, slot_cp2dir, CTRL+Key_G, false, false);
    mv2dirAct=addTA(this, NULL, mv2dirImg, _Spc, mv2dirChs, slot_mv2dir, CTRL+Key_I, false, false );
    renAct=addTA(this, NULL, -1, _Spc, renChs, slot_ren, Key_F2, false, false);
    attribAct=addTA(this, NULL, attribImg, _Spc, attribChs, slot_attrib, Key_F4, false, false);
    delAct=addTA(this, NULL,delImg, _Spc, removeChs, slot_del, Key_Delete, false, false);
    vdelAct=addTA(this, NULL,tagRemImg, _Spc, vdelChs, SLOT(vdel()), Key_F8, false, false);
    selAllAct=addTA(this, NULL, -1, _Spc, selAllChs, slot_selall, CTRL+Key_A, false, false);
    fspConAct=addTA(this, NULL, fspZoneImg,_Spc, "Fsplus zone", SLOT(fspZone()), CTRL+Key_Return, false, false);
    sImageAct=addTA(this, NULL, simpleImageImg, _Spc, sImageChs, SLOT(sImage()), CTRL+Key_I, false, false);
    sortAccel=new QAccel(this);
    for(i=0; i<9; i++)sortAccel->insertItem(QKeySequence(CTRL+Key_1+i), 60000+i);
    connect(sortAccel, sig_activated, this, slot_sortAccel );
//    clearWState( WState_Polished );
    startTimer(180);
}

/*
 *  Destroys the object and frees any allocated resources
 */
SearchModify::~SearchModify()
{
delete painter;
delete fmtr;
free((void *)_smwdg_[0]);
free((void *)_smwdg_);
free(SMpms);
if(sm_preCnt>0)free(sm_pms);
MAU mau;
int ibu[4];
mau.buf=(char *)ibu;
ibu[0]=__uid;	ibu[1]=__gid;
ibu[2]=early_dt;	ibu[3]=late_dt;
mau.len=sizeof(int)*4;	mau.alen=0; //sizeof(int)*4;
numbWrite(fspRoot, sm_datasId, &mau, 1);
if(pfdat)FreeTD(pfdat, true);
mau.buf=smColOpt;
mau.len=colOptCnt*2;
// mau.alen=0;
numbWrite(fspRoot, sm_colOptId, &mau, 1);
sm_filterNull=filterNull;
sm_kwCodeComboIdx=kwCodec;
sm_pathCodeComboIdx=pathCodec;
if(smThread==-3)QApplication::postEvent( qApp, new QCloseEvent );
}

void SearchModify::codecComb(QComboBox *combo, int c)
{
    QTextCodec *code;
    int i;
    char buff[80];
    combo->insertItem("*");
    sprintf(buff, localSet, QTextCodec::codecForLocale()->name());
    combo->insertItem(QString::fromUtf8(buff));
    combo->insertItem(QString::fromUtf8(Union16));
    combo->insertItem(QString::fromUtf8(Union8));
    for(i=0; ( code=QTextCodec::codecForIndex(i) ); i++)
	combo->insertItem(code->name());
    combo->setCurrentItem(c+1);
}

QTextCodec *sm_PathCodec;

void SearchModify::logEnabled(const QString &str)
{
QApplication::beep();
smLog.append(str);
}

int SearchModify::smBackup(const char *fname, FastBlock *bakup)
{
static const char ext[]=".smb";
int rt=0, fnLen=strlen(fname);
char *pt, *fnbuf=(char *)malloc(fnLen+5);
scopy(fnbuf,fname);
if(memstr(fname, fnLen+1, ext, 5, 3)==NULL)scopy(fnbuf+fnLen, ext);
if(access(fnbuf, W_OK)==0)remove(fnbuf); // include to test
if(rename(fname, fnbuf))rt=-2;
else {
	pt=strrchr(fnbuf,'/');
	if(pt)pt++;
	else pt=fnbuf;
	bakup->add(pt);
	}
if(rt==-2)logEnabled(QString::fromUtf8(backupFail)+sm_PathCodec->toUnicode(fname));
free(fnbuf);
return rt;
}

void SearchModify::addList(const char *chs)
{
	shwCnt++;
	while(shwCnt - sm_cnt>1)usleep(600);
	struct sm_params *smpms=(struct sm_params *)zalloc(sizeof(struct sm_params)); // z => mdf=0;
	smpms->fnam=strdup(chs);
	while(waitMsg)usleep(1000);
	appPost(Event_AddItem, smpms, this);
}

bool SearchModify::lmtStat(struct stat64 &src_st, const struct findparams *fndpm)
{
return ((fndpm->sizelmt0>-1&& src_st.st_size<fndpm->sizelmt0||fndpm->sizelmt1>-1 && src_st.st_size>fndpm->sizelmt1)
	|| (fndpm->timelmt0>0 && src_st.st_mtime<fndpm->timelmt0 || fndpm->timelmt1>0 && src_st.st_mtime>fndpm->timelmt1)
	|| ( sm_user && fndpm->uId!=src_st.st_uid|| sm_group && fndpm->gId!=src_st.st_gid ) );
}

void SearchModify::doSM(const char *chs, struct stat64 &src_st, int Msg, const struct findparams *fndpm, FastBlock *bakup)
{
if(lmtStat(src_st, fndpm))return;
const char *ptr=strrchr(chs, '/');
if(ptr)ptr++;
else ptr=chs;
if(sm_bakup&&(Msg==FIND_RE_PLACE||Msg==FIND_CUT))if(bakup->find(ptr)>-1)return;
if(namefilters(ptr, fndpm->filters, 1|(sm_pathCase? 2:0) )==false)return;
if(Msg!=FIND_NAME){
	int rt=-1;
	if(is_dev(src_st.st_mode))return;
	if(sm_binMode||(smTag&4)){
		rt=SMfile(chs, fndpm->kwFind, fndpm->kwRepl,
			smTag|(Msg==FIND_RE_PLACE ? 8:0)|(Msg==FIND_CUT ? 16:0)|(sm_runCase ? 2:0)|(sm_wholeWord ? 512 : 0)|(sm_bakup ? 1:0)
			,bakup);
	}
	else {
	   FILE *fp=fopen64(chs, "rb");
	   if(fp){
		long long sz=src_st.st_size;
		QTextCodec *code=kwCodec>-1 ? _setCodec(kwCodec) : strCodec;
		QString str, fnd;
		char *pt=(char *)malloc(sz+2);
		if(pt==NULL){
			logEnabled(tranText(strCodec,strerror(errno))+tranText(sm_PathCodec,chs));
			return;
			}
		fread(pt, sz, 1, fp);
		pt[sz]=0;
		fclose(fp);
		str=code->toUnicode(pt);
		free(pt);
		fnd=code->toUnicode(fndpm->kwFind);
		rt=0;
	_find_:	rt=str.find(fnd, rt, sm_runCase);
		if(rt>-1){
			if(sm_wholeWord){
				if(strchr(div_syb, ((const char *)str)[rt+strlen(fnd)])==NULL||
					(rt>0&&strchr(div_syb, ((const char *)str)[rt-1])==NULL)){
						rt++;	goto _find_;
					}
			}
			if(Msg==FIND_RE_PLACE||Msg==FIND_CUT){
				if(sm_bakup)smBackup(chs, bakup);
				FILE *wf=fopen(chs,"wb");
				if(wf){
				  str.replace(fnd, Msg==FIND_CUT ? "" : code->toUnicode(fndpm->kwRepl));
				  QCString s(code->fromUnicode(str));
				  fwrite(s, s.length(),1,wf);
				  fclose(wf);
				}
				else rt=-2;
			}
		   }
	    }
	}
	if(sm_reset)
		switch(rt){
		case -2 :
		case -3 :logEnabled(sm_PathCodec->toUnicode(chs)+QString::fromUtf8(_smwdg_[rt+4+Int_canotOpen]));
		case 1 : return;
		}
	else 
		switch(rt){
		case -1 : return;
		case -2 :
		case -3 : 
		case -4 :	QApplication::beep(); 
			logEnabled(sm_PathCodec->toUnicode(chs)+QString::fromUtf8(_smwdg_[rt+4+Int_canotOpen]));
			if(rt==-4)return;
		}
}
if(Msg==FIND_RE_PLACE||Msg==FIND_CUT)chmod(chs, src_st.st_mode);
addList(chs);
}

void fmtInps(char *pth)
{
char *pt;
while( (pt=strstr(pth," /")) )
	*pt='\n';
}

inline int SearchModify::SMfile(const char *fname, const char *chkstr, const char *repstr,int msg, FastBlock *bakup)
{
/*
msg=> is -1 is return 1; (no scan). all bit no effect,
0 bit: back file(1), 1 bit: CS(2), 2 bit: use loaddata(4),
3 bit: replace(8),
4 bit: if 3 bit is 0,4 bit setbit, then del chs(16)
*/
static const char FWB[]="wb+", 
repltmp[]="repl_tmp.smd", repltmp2[]="repl2tmp.smd";
int memstr_Msg, result;
FILE *repf, *fptr, *swp;
long long fsz, fwtlen, /* must long, as wtlen=fpos in code */
 sCount; /* read(src) file size & count read dk */
unsigned int ctn, /* use to calc pdat->toluse */
txtbufsz=0, oldbsz,/* alloc mem sz for buff */
realsz, /* mm len which read src (txtbuf len) */
rdlen,
mwtlen, /* don't take fwtlen as mwtlen is easy, as int use smart more than long */
wtDatlen,/* scan part of txtbuf len */
mem_off, bufpos, i, t,  Idx, // for holl-word
chklen, replen, rScanLen;
char *fcreat=NULL, *fcreat2=NULL, *flast,
*pAlloc=NULL, *txtbuf, *cmpRt;
const char *chk, *rep, *wtDat;
bool MultSch, readinto, ReplFind=false;/* init for readinto depend on */

memstr_Msg=1|(msg&2)|(msg&128); // 128 => ? Tong
if( (MultSch=(msg&SCAN_TDS)) ){
	ctn=0;	
	if(pfdat->toluse==0)return 1;
	}
else { 
	chk=chkstr; rep=repstr;
	chklen=strlen(chk);
	if((msg&8) && rep )replen=strlen(rep);/* TDS & input have defence null */
	}

if(msg&(8|16)){
	fname=realpath(fname, NULL);
	if(sm_cnt>0){
		flast=(char *)malloc(2048);
		t=1;
		for(i=0; i<sm_cnt&&t; i++){
			realpath(sm_pms[i].fnam, flast);
			t=strcmp(flast, fname);
		}
		free(flast);
		if(t==0)return -1;
	}
}

if((fptr=fopen64(fname,"rb"))==NULL){
	result=-4;
	goto _ex_;
	}

result=-1;

#define reallmt 0x20000
chkstart:	mem_off=0;
fseek(fptr,0,2);
if((fsz=ftell(fptr))==0)
	goto breakloop;
/* fsz change every times, don't use filelenght */

if( (readinto=(ReplFind||fsz>txtbufsz)) )rewind(fptr);

if(MultSch){
	chk=pfdat->oDat[ctn]; rep=pfdat->nDat[ctn];
	chklen=pfdat->oLen[ctn];	replen=pfdat->nLen[ctn];
	}

fwtlen=0;	sCount=0;
rScanLen=chklen-1;
oldbsz=txtbufsz;
txtbufsz=fsz>reallmt? reallmt:fsz;
if(txtbufsz>oldbsz){
	if(pAlloc)free(pAlloc);
	pAlloc=(char *)malloc(txtbufsz+4);
	txtbuf=pAlloc+1; // for holl-word
}
pAlloc[0]='\n';
bufpos=0; ReplFind=false; /* init every time */

_begin_: Idx=0;	rdlen=txtbufsz-bufpos;
realsz=fsz > (sCount+rdlen) ? rdlen : fsz-sCount;
if(readinto)fread(txtbuf+bufpos+mem_off,realsz+1-mem_off,1,fptr);
mem_off=1; // for holl-word
sCount+=realsz;	realsz+=bufpos;
// txtbuf[realsz+2]=0;
_search_: cmpRt=memstr(txtbuf+Idx, realsz-Idx, chk, chklen, memstr_Msg);

if(cmpRt){
   if( (msg&512) &&
	(strchr(div_syb, cmpRt[chklen])==NULL||/*cmpRt!=txtbuf && */strchr(div_syb, cmpRt[-1])==NULL) ){
	Idx=cmpRt-txtbuf + 1;
	if(Idx>=realsz)goto _noFind_;
	goto _search_;
	}
  result=1;
  if(msg&24){ // (8|16)==24
	if(fcreat==NULL){ /* create repalce file */
		fcreat=fixpath(fname, repltmp);
		if((repf=fopen64(fcreat,FWB))==NULL){/* mem have chk, main is disk error */
			result=-3; // dir no write
			goto breakloop;
			}
		flast=fcreat;
		}	/* create file end */

     if(!ReplFind && sCount>realsz ){ /* skip have scaned blk(begin_file) to write current found */
	fwtlen=sCount-realsz; fseek(repf,fwtlen,0);
	}
/*  write (have read into mem)txtbuf to repf 	*/
	wtDat=txtbuf;	wtDatlen=realsz;
	_loop_: Idx=0;
	  mwtlen=cmpRt-wtDat;
	  if(mwtlen>0)fwrite(wtDat,mwtlen,1,repf);
	  if((msg&8)&&rep)fwrite(rep,replen,1,repf);/* replace */
	  if(wtDatlen<=mwtlen+chklen){
		pAlloc[0]='\n';
		bufpos=0;
		txtbuf[0]=txtbuf[realsz];
		goto skpwt;
		}
	  wtDat=cmpRt+chklen;
	  wtDatlen-=mwtlen+chklen;
	  _search2_: cmpRt=memstr(wtDat+Idx, wtDatlen-Idx, chk, chklen,memstr_Msg);
	  if( cmpRt ){ 
		if((msg&512)&&(strchr(div_syb, cmpRt[chklen])==NULL|| strchr(div_syb, cmpRt[-1])==NULL) ){
			Idx=cmpRt-wtDat + 1;
			if(Idx<wtDatlen)goto _search2_;
		}
		else goto _loop_;
	  }

	if(sCount<fsz){ /* this must rescan next loop */
		if(wtDatlen>rScanLen){
		  wtDatlen-=rScanLen;
		  bufpos=rScanLen;
		  fwrite(wtDat,wtDatlen,1,repf);
		  pAlloc[0]=txtbuf[realsz-bufpos-1];
		}
		else { bufpos=wtDatlen;	pAlloc[0]='\n';  }
//		memcpy(txtbuf,txtbuf+realsz-bufpos,bufpos+1); // word right-bind
		for(t=realsz-bufpos, i=0; i<bufpos+1; i++)txtbuf[i]=txtbuf[t+i];
		}
	else fwrite(wtDat,wtDatlen,1,repf);
  skpwt:  ReplFind=true;
  }/* modify */
  else goto breakloop;/* Only-find & found it */
}/* cmpRt!=null(find it) */
else { // last edit by xempo 2014-6-16
_noFind_:if(sCount<fsz)realsz-=rScanLen;
	if(ReplFind)fwrite(txtbuf,realsz,1,repf);
	if(sCount>=fsz)goto _out_;
	bufpos=rScanLen;
//	memcpy(pAlloc, txtbuf+realsz-1, chklen+1); // +1 is word right-bind
	for(t=realsz-1, i=0; i<chklen+1; i++)pAlloc[i]=txtbuf[t+i];
}/* as have mdf, so write data to it at once */

if(smThread>0 && sCount < fsz )goto _begin_;

_out_: if(ReplFind){
  if(MultSch)ftruncate(repf->_fileno, ftell(repf));/* every mdf must fix lenght */
  if(fwtlen){ /* write begin blk which no found */
	/*long fpos=ftell(repf); next write pos */
	rewind(fptr);        rewind(repf);
	while(fwtlen>0){
	  rdlen=fwtlen<(long long)txtbufsz ? fwtlen:txtbufsz;
	  fread(txtbuf,rdlen,1,fptr);
	  fwrite(txtbuf,rdlen,1,repf);
	  fwtlen -= rdlen;
		}
	/*fseek(repf,fpos,0);*/ /* rego next write pos */
     }
}

if(MultSch){
 if(++ctn<pfdat->toluse){
  if(ReplFind){/* here is modify-mode */
   if(fcreat2==NULL){
	fclose(fptr);	/*fflush(repf);*/
	fptr=repf;
	fcreat2=fixpath(fname, repltmp2);
	if((repf=fopen64(fcreat2,FWB))==NULL){/* mem have test, perhan is disk error */
	//	RunMsg=3; /* disable modify org-file */
		result=-3; // dir no write
		goto breakloop;
		}
	}
	else {	
		swp=fptr; fptr=repf; repf=swp;
		rewind(repf);
	}
	flast=flast==fcreat? fcreat2:fcreat;
  }/* found it */
  goto chkstart;
}
if(ReplFind==false && fcreat2 )flast= flast!=fcreat2? fcreat2:fcreat;
}

breakloop: fclose(fptr);

if(result==1&&(msg&24)){
/* file and its statue is deffer, and the fclose in follow. */
   if(repf){
	fclose(repf);
	if(msg&1)smBackup(fname, bakup);
	else remove(fname);
	if(rename(flast,fname))result=-2; // file no write
	if(fcreat2){
		remove(flast!=fcreat2? fcreat2:fcreat);/* remove other temp file */
		free(fcreat2);
		}
	}
	free(fcreat);
}/* result=1 */
if(pAlloc)free(pAlloc);
_ex_: if(msg&(8|16))free((void *)fname);
return result;
}

#define onlyFindName(pms) (pms->uId==-1&&pms->gId==-1 && pms->sizelmt0==-1 && pms->sizelmt1==-1&& pms->timelmt0==0 && pms->timelmt1==0)
#include <dirent.h>
int  SearchModify::acceDir(int Msg, const char *fdirnam,   const struct findparams *pms)
{
 struct stat64  src_st;
 if(stat64(fdirnam, &src_st)){
	if(firstLoop==false)postErrInfo(this, ErrorQ, fdirnam, warnChs);
	return  none_File;
	}
 if( isReadable(uId, gId, &src_st)==false ){
	if(firstLoop==false)postInfoWidget(this, ErrorQ, fdirnam, noRightOpera, warnChs );
	return no_Right;
	}
  int rt2=0, L, info;
  const char *fnam;
  struct dirent *dire;
  char *chs;
  DIR *dir;
  FastBlock bakup;
  if( S_ISDIR(src_st.st_mode) ){
	if( !isExecable(uId, gId, &src_st) &&Msg!=FIND_NAME){
		if(firstLoop==false)postInfoWidget(this, ErrorQ, fdirnam, dirNoExe, NULL );
		return dir_no_exe;
		}
	}
  else {
	doSM(fdirnam, src_st, Msg, pms, &bakup);
	return 1;
	}
  firstLoop=true;
  L=strlen(fdirnam);
  chs=(char *)malloc(L+258);
  scopy(chs, fdirnam);
  if(chs[L-1]!=ROOT_CH)chs[L++]=ROOT_CH;
  dir=opendir(fdirnam);
  while( smThread>0&&rt2!=opera_cancel && ( dire=readdir(dir))!=NULL ){ // && rt2!=cp_ignoreThrow && rt2!=opera_error
    fnam=dire->d_name;
    if( ! (fnam[0]=='.' && (fnam[1]==0 ||( fnam[1]=='.'&&fnam[2]==0))) ){
	scopy(chs+L, fnam);
	info=stat64(chs, &src_st);
	if( info==0 && S_ISDIR(src_st.st_mode)){
		if(sm_includeSub)rt2=acceDir(Msg, chs, pms);
		if(pms->kwFind==NULL && lmtStat(src_st, pms)==false &&
			namefilters(fnam, pms->filters, 1|(sm_pathCase? 2:0) ) )
			addList(chs);
	  }
	else if(info==0||(Msg==FIND_NAME && onlyFindName(pms)) )doSM(chs, src_st, Msg, pms, &bakup);
	}
  }
  free(chs);
  closedir(dir);
  return rt2; //!=opera_cancel ? (rt2<0 ? 128 : 0) : opera_cancel; 
}

void SearchModify::adjFindMode()
{
if(sm_cnt==0&&operaListTag==true){
	operaListTag=false;
	operaListAct->setOn(false);
	findAct->setIconSet(*pixmapLoad(findImg));
	replAct->setIconSet(*pixmapLoad(searchModifyImg));
	searchCutAct->setIconSet(*pixmapLoad(searchCutImg));
}
}

void SearchModify::removeItem(LVItem *it, int idx)
{
	memmove( sm_pms+idx, sm_pms+idx+1, sizeof(struct sm_params)*(--sm_cnt - idx));
	_vList->takeItem(it);
	filesor->delLVItem(it);
	if(smThread!=1){
		setRunStatus();
		saveResultAct->setEnabled(sm_cnt);
		operaListAct->setEnabled(sm_cnt);
		adjFindMode();
	}
}

void *thrSearch(void *sm)
{
((SearchModify *)sm)->run();
return NULL;
}

void SearchModify::quitThread()
{
if(smThread>0)smThread=-1;
while(runSearch)
	usleep(300);
usleep(200); // safe
}

void SearchModify::run()
{
   runSearch=true;
   logRecorde(smLog, startChs);
   if(operaListTag){
	struct stat64 st;
	char *fn;
	int cn=operalst.memDiv(NULL), i, L;
	FastBlock bak;
	L=strlen(SMpms->pth);
	for(i=0; i<cn&&smThread>0; i++){
		fn=operalst.lstIndex(i);
		if(stat64(fn, &st)==0 && strstr(fn, SMpms->pth)==fn&&(fn[L]=='/'||fn[L-1]=='/'||fn[L]==0) )
			doSM(operalst.lstIndex(i), st, smCmd, SMpms, &bak);
	}
	operalst.resetMem(NULL);
	}
    else {
	firstLoop=false;
	acceDir(smCmd, SMpms->pth, SMpms);
	}
   logRecorde(smLog, endChs);
   if(smLogList.count()==0)
	appPost(Event_Error, NULL, this);
   smLogList+=smLog;
   smLog.clear();
   runSearch=false;
   if(smThread>-2) smThread=-4; // stop status
}

const char *SearchModify::getchs(const QString &str, int code)
{
return strdup(code>-1 ? __fromUnicode(str, code) : __from_unicode(str));
}

void SearchModify::resetList(bool res)
{
int i, cn;
if(res){
	LVItem *it=(LVItem *)_vList->firstChild();
	while(it){
		operalst.add(it->fnam);
		it=(LVItem *)it->nextSibling();
	}
}
cn=_vList->columns(); // perhans change list-column in main-view
for(i=2; i<cn; i++)_vList->removeColumn(2);
creatFileList(this, _vList, smColOpt, smUseCols, 3);
}

void SearchModify::findStart(int sw)
{
// int i;
quitThread();
if(sw==10){ // returnPressed in replaceComb
	startMsg=true; sw=1;
}
if(sw<8){
  kwRepl=replaceCombo->currentText();
  if(kwRepl.isEmpty()){
	if( sm_TDS==0 && sw==1 )sw=2;
	}
  else replaceCombo->comboAdd(kwRepl);
  kwFind=keywordCombo->currentText();
  if( kwFind.isEmpty() )sw=3; // only find name
  else keywordCombo->comboAdd(kwFind);
}
if((sw==1||sw==2) &&
	infoWidget(NULL, NULL, SearchModifyWarn+sw-1, this) )return;
if(operaListTag)resetList(true);
smTag=0;
if(SMpms->pth)free((void *)SMpms->pth);
if(SMpms->kwFind)free((void *)SMpms->kwFind);
if(SMpms->kwRepl)free((void *)SMpms->kwRepl);
if(SMpms->filters)free((void *)SMpms->filters);
memset(SMpms,0,sizeof(findparams));

pathCodec=pathCodeCombo->currentItem()-1;

pathStr=pathCombo->currentText();
if(pathStr.isEmpty()){
	pathCombo->setCurrentText(QString::fromLocal8Bit(filesor->getDirNam()));
	pathStr=pathCombo->currentText();
	}

SMpms->pth=(char *)getchs(pathStr, pathCodec);
pathCombo->comboAdd(pathStr);

filterStr=filterCombo->currentText();
if(filterStr.isEmpty()==false){
	SMpms->filters=(char *)getchs(filterStr, pathCodec);
	filterCombo->comboAdd(filterStr);
}

sm_PathCodec=curCodec(); // pathCodec>-1 ? _setCodec(pathCodec) : strCodec;

sm_bakup=bakupChk->isChecked();
kwCodec=kwCodecCombo->currentItem()-1;

if(fsizeCombo0->isEnabled()&&fsizeCombo0->currentText().isEmpty()==false){
	SMpms->sizelmt0=atoll(fsizeCombo0->currentText());
	fsizeCombo0->comboAdd(fsizeCombo0->currentText());
	}
else SMpms->sizelmt0=-1;
if(fsizeCombo1->isEnabled()&&fsizeCombo1->currentText().isEmpty()==false){
	SMpms->sizelmt1=atoll(fsizeCombo1->currentText());
	fsizeCombo1->comboAdd(fsizeCombo1->currentText());
	}
else SMpms->sizelmt1=-1;
if(earlyDateTime->isEnabled())SMpms->timelmt0=earlyDateTime->dateTime().toTime_t();
else SMpms->timelmt0=0;
if(lateDateTime->isEnabled())SMpms->timelmt1=lateDateTime->dateTime().toTime_t();
else SMpms->timelmt1=0;
early_dt=SMpms->timelmt0;
late_dt=SMpms->timelmt1;
SMpms->uId=-1;
SMpms->gId=-1;
if( sm_user ){
	__uid = usrIDs[usrList->count()-1-userCombo->currentItem()];
	SMpms->uId=__uid;
	}
if( sm_group ){
	__gid=groupIDs[grpList->count()-1-groupCombo->currentItem()];
	SMpms->gId=__gid;
	}
if(kwRepl.isEmpty()==false)SMpms->kwRepl=getchs(kwRepl,kwCodec);
if(kwFind.isEmpty()==false)SMpms->kwFind=getchs(kwFind,kwCodec);

if(sw<8){  // findStart(8) is save setting when exit
	if(sm_TDS){
	  char *pt=strdup(curCodec()->fromUnicode(keywordCombo->currentText()));
	  if(pfdat==NULL)pfdat=(TxtDat *)zalloc(sizeof(TxtDat));
	  else FreeTD(pfdat, false);
	  fmtInps(pt);
	  CreatTD(pfdat, pt, 1, this, &pathList);
	  free(pt);
	  if(pfdat->toluse<1)return;
	  smTag=SCAN_TDS;
	}
	shwCnt=0;
	sm_cnt=0;
	if(sm_preCnt>360){
		free(sm_pms);
		sm_preCnt=0;
	}
	_vList->clear();
	smCmd=sw+FIND_KEYWORD;
	findAct->setEnabled(false);
	replAct->setEnabled(false);
	searchCutAct->setEnabled(false);
	operaListAct->setEnabled(false);
	stopAct->setEnabled(true);
	_vList->header()->setSortIndicator(-1, false);
	sortA=false;
	tms=2;
	sbar->showMsg(NULL,-1); // must clear
	tabs->showPage(_vList);
	smThread=1;
	pthread_t thr;
	pthread_attr_t  attr;
	pthread_attr_init( &attr );
	pthread_attr_setschedpolicy(&attr, 1);

	pthread_attr_setstack(&attr, malloc(PTHREAD_STACK_MIN*40), PTHREAD_STACK_MIN*40);
	pthread_create(&thr, &attr, thrSearch, this);
}
}

void SearchModify::setResult()
{
	char buf[200];
	sprintf(buf, smCmd!=FIND_RE_PLACE&&smCmd!=FIND_CUT ? foundChs : modifyChs, sm_cnt);
	sbar->showMsg(buf, 0, false, 0x232399);
	tms=-10;
}

void SearchModify::setRunStatus()
{
if(smThread==1){
	char buf[200];
	sprintf(buf, foundChs, sm_cnt);
	QString s(QString::fromUtf8(buf));
	tms=0;
	int Len=sbar->width(), B=fmtr->size(Qt::SingleLine, s).width();
	painter->eraseRect(QRect(orgb, 0, orgw, sbar->height()));
	orgw=fntSz/4+26+B;
	orgb=Len-orgw;
	if(++wheel_SM>2)wheel_SM=0;
	painter->drawPixmap(Len-fntSz/4-26, pixBPos, *freqPix[wheel_SM+ICO_SEARCH] );
	painter->drawText(orgb, fntBPos, s );
	}
else setResult();
}

bool SearchModify::event(QEvent *e)
{
switch(e->type()){
case QEvent::Timer : 
	switch(smThread){
	case -2 :
	case -3 : if(runSearch==false)close();
	case -1 : // during quitThread
		break;
	case 0 : if(tms++>11&&runSearch==false){
			tms=0;
			smThread=2;
			appPost( virtual_notify, NULL, this);
			}
		break;
	case -4 :	replAct->setEnabled(!_Params[28]/* sm_reset && sm_cnt&&smCmd==FIND_KEYWORD*/);
		searchCutAct->setEnabled(!_Params[28]/*&& sm_cnt&&smCmd==FIND_KEYWORD*/);
		saveResultAct->setEnabled(sm_cnt);
		operaListAct->setEnabled(sm_cnt);
		adjFindMode();
		findAct->setEnabled(true);
		replAct->setEnabled(true);
		searchCutAct->setEnabled(true);
		stopAct->setEnabled(false);
		smThread=0;
		goto _statu_;
	case 1 :  if(tms++>0)_statu_: setRunStatus(); //statusLab->repaint();
	}
	return false;
case QEvent::Close : 
	if(cpEvent){ 
		if(smThread>-1)smThread=-2;
		return false;
		}
	if(runSearch){
		if(smThread>0)smThread=-2; // perhan is -3
		return false;
	}
	filesor->setSMW(NULL);
	findStart(8/* save pms */);
	saveListColWidth(_vList, SM_ColumnWidthsId);
	keywordCombo->comboTo(p_kwFindlst);
	replaceCombo->comboTo(p_kwRepllst);
	pathCombo->comboTo(p_smpath);
	filterCombo->comboTo(p_smfilter);
	fsizeCombo0->comboTo(p_fsize0lst );
	fsizeCombo1->comboTo(p_fsize1lst );
	break;
case QEvent::KeyPress : 
	switch(((QKeyEvent *)e)->key()){
	case Key_Return :
		if(startMsg==false)findStart(0);
		else startMsg=false; // Press return in comboboxes
		break;
	case Key_F12 : showTop(filesor);
		break;
	case Key_Q : smThread=-3;
	}
	break;
case QEvent::Resize : // if(smMode==0)sizeAdjust();
{
    int py, i, t, h2=height(), H2, d, _H, combH, ahead, panelLen, off, off3, L, _off,
	H0=fntSz*10/7, div=fntSz/2, D=fntSz/6;
// hg_ref : hgref=x:height => x=height()*hg_ref/hgref => _h=x-hg_ref;
// 11 lines, 4 kuang, base=> b=everylines, kuang=1.5b => total 10+3*1.5+3*b=17.5b , b=_h/18.5=> b=_h*10/175; +bottom =>_h*10/185
    i=hg_ref*fntSz/_baseH_;
    _H=h2>600 ?  (h2*i/(hgref*fntSz/_baseH_) - i)*10/ 185 : 0;
    d=comD;
    h2=H0+_H+H0+_H+div;
    H2=h2+D;
    ahead=scalefloat(26);
    panelLen=width()-2*ahead;
    pathGroup->setGeometry(  ahead, div, panelLen, h2+H0+fntSz+_H  );
    combH=inputH;
    pathCombo->setGeometry( scalefloat(14), H0-d/2+_H, panelLen-scalefloat(150), combH );
    filterCombo->setGeometry( scalefloat(14+2) + (panelLen-scalefloat(150)), H0-d/2+_H, scalefloat(150-(14+2+12) ), combH );
    _off=width()-(632*fntSz/_baseH_);
    if(_off<0)_off=0;
    off=_off/4;
    L=scalefloat(117);
    subChk->setGeometry(  scalefloat(16), H2, L+off, H0 );
    pathCaseChk->setGeometry( scalefloat(117)+off, H2, L+off, H0  );
    L=scalefloat(400)+off*3;
    codeLab1->setGeometry(L-25, H2, 24, H0);
    pathCodeCombo->setGeometry(L, H2-d/2, panelLen-L-scalefloat(12), combH);
//____________________________________________________
    i=div+(h2+H0+fntSz+_H) + (_H*3/2)+fntSz;
    py=h2+H0+_H+div;
    t=py+H0+div+_H;
    keywordGroup->setGeometry( ahead, i, panelLen, t+H0+fntSz+_H  );
    kwfind->setGeometry( scalefloat(5), H0+_H, scalefloat(76), H0 );
    keywordCombo->setGeometry( scalefloat(86), H0-d/2+_H, panelLen-scalefloat(98), combH );
    kwrepl->setGeometry( scalefloat(5), H2, scalefloat(76), H0 );
    replaceCombo->setGeometry( scalefloat(86), H2-d/2, panelLen-scalefloat(98), combH );
    L=scalefloat(120);	py+=D;
    kwCaseChk->setGeometry( scalefloat(16), py, L+off, H0 );
    kwWordChk->setGeometry( scalefloat(156)+off, py, L+off, H0 );
    binChk->setGeometry( scalefloat(300)+off*2, py, L+off, H0 );
    bakupChk->setGeometry( scalefloat(440)+off*3, py, L+off, H0 );
    off3=_off/3;
    resetChk->setGeometry(  scalefloat(16), t+d/2, scalefloat(140)+off3, H0  );
    TDSChk->setGeometry(scalefloat(160)+off3, t+d/2, scalefloat(150)+off3, H0);
    L=scalefloat(408)+off3*2;
    codeLab2->setGeometry(L-25, t+d/2, 24, H0);
    kwCodecCombo->setGeometry(scalefloat(408)+off3*2, t, scalefloat(154)+off3, combH);
//______________________________________________________
    t+=H0+fntSz+_H +i + (_H*15/10)+fntSz;
    fileGroup->setGeometry( ahead, t, panelLen, h2+H0+fntSz+_H );
    static const int chkRect[3][2]={ { scalefloat(18), scalefloat(78) }, { scalefloat(250), scalefloat(78) }, { scalefloat(490), scalefloat(78) } };
    off=_off/2;
    for(i=0; i<3; i++)
	chk[i]->setGeometry( chkRect[i][0]+(i*off), H0+_H, chkRect[i][1], H0 );
    fsizeCombo0->setGeometry( scalefloat(92), H0-d/2+_H, scalefloat(145)+off, combH );
    fsizeCombo1->setGeometry( scalefloat(322)+off, H0-d/2+_H, scalefloat(145)+off, combH );
    fuser->setGeometry( scalefloat(18), H2, 126, H0 );
    userCombo->setGeometry( scalefloat(144), H2-d/2, scalefloat(140)+off, combH );
    fgroup->setGeometry( scalefloat(300)+off, H2, scalefloat(120), H0 );
    groupCombo->setGeometry( scalefloat(421)+off, H2-d/2, scalefloat(136)+off, combH  );
//____________________________________________

    t+=h2+H0+fntSz+_H+ (_H*15/10)+fntSz;
    timeGroup->setGeometry( ahead, t, panelLen, h2+H0+fntSz+_H  );
    earlyDateTime->setGeometry( scalefloat(28), H0+_H, scalefloat(250)+off, combH-d/2 );
    lateDateTime->setGeometry( scalefloat(302)+off, H0+_H, scalefloat(250)+off, combH-d/2 );
    static const int tmChkRect[3][2]={ {scalefloat(80), scalefloat(78) }, {scalefloat(260), scalefloat(78)}, {scalefloat(420), scalefloat(78) } };
    for(i=0; i<3; i++)
	tmChk[i]->setGeometry( tmChkRect[i][0]+(i*off3), H2, tmChkRect[i][1]+off3, H0 );
#define  hg  23
    upBtn->setGeometry(scaleRect(LeftWide, 40+270, 2*hg, hg+8 ));
    downBtn->setGeometry(scaleRect(LeftWide+2*hg+6, 40+270, 2*hg, hg+8 ));
    t=optList->x()+optList->width()+fntSz*2;
    _H=optList->y();
    orgStyleBtn->setGeometry(scaleRect(LeftWide+optListLen-4*hg, 40+270, 4*hg, hg+8 ));
    dtfmtLab->setGeometry(t, _H, width()-t-fntSz, combH );
    dtfmtCombo->setGeometry(t, _H+combH+fntSz-3, width()-t-2*fntSz, combH);

    grapShowChk->setGeometry(t, _H+combH*2+fntSz*2+3, width()-t-fntSz, combH );
    lmtSiz->setGeometry(t, _H+combH*3+fntSz*3, width()-t-2*fntSz, combH );
    grapCombo->setGeometry(t+scalefloat(108), _H+combH*3+fntSz*3, width()-t-scalefloat(108)-2*fntSz, combH );
}
}
return QMainWindow::event(e);
}

extern const QMetaData orgStyleSlot;
QMetaObject *SearchModify::metaObj=NULL;
static QMetaObjectCleanUp cleanUp_SearchModifyPan( search_modify, &SearchModify::staticMetaObject );
QMetaData popPluzoneSlot={"popPluzone()" ,&slot_0_0, QMetaData::Private },
	stopSlot={"stop()", &slot_0_0, QMetaData::Private },
	findSlot={"find()", &slot_0_0, QMetaData::Private },
	find2Slot={"find2()", &slot_0_0, QMetaData::Private }; // replace

QMetaObject* SearchModify::staticMetaObject()
{
if(metaObj==NULL){
    static const QMetaData slot_tb[]={
	findSlot,
	find2Slot, // replace
	{"smCut()", &slot_0_0, QMetaData::Private },
	{"vdel()", &slot_0_0, QMetaData::Private },
	{"hlp()", &slot_0_0, QMetaData::Private },
	addSrcSlot,
	{"saveResult()", &slot_0_0, QMetaData::Private },
	clearPESlot, // 7
	attribSlot,
	closeAllWdgSlot,
	{"Sz1()", &slot_0_0, QMetaData::Private }, //10
	{"Sz2()", &slot_0_0, QMetaData::Private },
	{"Sz3()", &slot_0_0, QMetaData::Private },
	{"T1()", &slot_0_0, QMetaData::Private },
	{"T2()", &slot_0_0, QMetaData::Private },
	{"T3()", &slot_0_0, QMetaData::Private }, // 15
	{"smClose()", &slot_0_0, QMetaData::Private },
	orgStyleSlot,
	popPluzoneSlot, //
	{"fuser()", &slot_0_0, QMetaData::Private }, 
	{"fgroup()", &slot_0_0, QMetaData::Private }, // 20
	{"sub()", &slot_0_0, QMetaData::Private },
	{"pathCS()", &slot_0_0, QMetaData::Private },
	{"findCS()", &slot_0_0, QMetaData::Private },
	{"findBM()", &slot_0_0, QMetaData::Private },
	{"findWord()", &slot_0_0, QMetaData::Private },
	{"reset()", &slot_0_0, QMetaData::Private },// 26
	{"TDS()", &slot_0_0, QMetaData::Private },

	{ "PZpath()", &slot_0_0, QMetaData::Private },
	selAllSlot,
	deleteSlot,
	{"smLog()", &slot_0_0, QMetaData::Private },
	asSrcSlot,
	proEditSlot, //33
	sortSlot,
	dbclickSlot,// 35
	enterSlot,
	openSlot,
	opensSlot, // 38

	chSelSlot,
	recentSlot,
	menuOpenSlot,
	sortAccelSlot,
	{ "grapChk()", &slot_0_0, QMetaData::Private },
	stopSlot,
	toggRenSlot,
	doRenSlot,
	{"OL()", &slot_0_0, QMetaData::Private }, // 47
	upSlot,
	downSlot,
	{ "smDtFmt()", &slot_0_0, QMetaData::Private }, // 50
	{ "chTab()", &slot_ptr, QMetaData::Private },

	{ "cp2dir()", &slot_0_0, QMetaData::Private }, // 52 - 54 don't change
	{ "selSiz()", &slot_0_0, QMetaData::Private },
	{ "mv2dir()", &slot_0_0, QMetaData::Private }, // 52 - 5 4don't change
	{ "dirsum()", &slot_0_0, QMetaData::Private },
	fspZoneSlot,
	sImageSlot
	};
    metaObj = QMetaObject::new_metaobject(search_modify, QMainWindow::staticMetaObject(), slot_tb, 58,
	0, 0,
#ifndef QT_NO_PROPERTIES
	0, 0,
	0, 0,
#endif // QT_NO_PROPERTIES
	0, 0 );
    cleanUp_SearchModifyPan.setMetaObject( metaObj );
}
return metaObj;
}

QTextCodec *SearchModify::curCodec()
{
return 	(pathCodec>-1 ? _setCodec(pathCodec) : strCodec);
}

void SearchModify::chSelect()
{
fsels.resetMem(NULL);
_vList->selectedCollect(&fsels, sbar);  // flist selectedChange, can use currentItem() ?
}

void SearchModify::insertList(struct sm_params *pms, int M)
{
	if(sm_cnt>=sm_preCnt){
	  struct sm_params *tmp;
	  sm_preCnt+=32;
	  tmp=(struct sm_params *)malloc(sm_preCnt*sizeof(struct sm_params));
	  if(sm_cnt>0){
		memcpy(tmp, sm_pms, sm_cnt*sizeof(struct sm_params));
		free(sm_pms);
		}
	  sm_pms=tmp;
	}
	vInsertItem(_vList, pms->fnam, M,
		grapSizLmt, smUseCols, sm_dtfmt, sm_PathCodec, &pms->opt);
	sm_pms[sm_cnt++]=*pms;
}

void SearchModify::adjListView(bool res)
{
        int i, t;
        tms=-1000;
        getListOpts(optList, smColOpt+colOptCnt);
        if(memcmp(colsbak, smColOpt, 2*colOptCnt)||orgDtfmtIdx!=sm_dtfmtCombIdx||
	org_grapShow!=sm_grapShow||grapSizLmt!=org_SizLmt){
	resetList(res);
	memcpy(colsbak, smColOpt, 2*colOptCnt);
	if(res==false)goto _ex_;
	struct sm_params pms;
	t=operalst.memDiv(NULL);

	shwCnt=0;	sm_cnt=0;
	if(sm_preCnt>360){
		free(sm_pms);
		sm_preCnt=0;
		}
	QListViewItem *it=_vList->firstChild();
	for(i=0; i<t; i++){
		memset(&pms, 0, sizeof(struct sm_params));
		pms.fnam=strdup(operalst.lstIndex(i));
		pms.opt.item=it;
		insertList(&pms, ListSet_Chang  );
		it=it->nextSibling();
		}
	operalst.resetMem(NULL);
        }
_ex_:        tms=0;
}

void QWidget::paintEvent(QPaintEvent *e)
{
if(name() && strcmp(__listSet,name())==0)((SearchModify *)topLevelWidget())->grapDemo(false);
}

void SearchModify::grapDemo(bool erase)
{
	QPainter pn(listSet);
	QImage img;
	if(sm_grapShow)img=*pixmapLoad(pluzoneModulImg); // : *filepix;
	int x=grapCombo->x()+fntSz,
		y=grapCombo->y()+fntSz*3;
	if(erase)pn.eraseRect(x, y, 128, 128);
	pn.drawPixmap( x, y, sm_grapShow ? img.smoothScale(grapSizLmt,grapSizLmt) : *freqPix[ICO_NORM] );
}

bool SearchModify::qt_invoke(int _id, QUObject *_uo)
{
int i, t, sw=_id-staticMetaObject()->slotOffset();
LVItem *it;
switch(sw){
case 2 :
case 1 :
case 0 :	if(tabs->currentPage()==listSet){
	    quitThread();
	    adjListView(listSetMsg);
	    listSetMsg=false;
	}
	findStart(sw); // 3 is search name only
	break;
case 39 : chSelect();
	break;
case 10 : // large
case 11 :
case 12 : if(sm_szChk!=sw-9){
		if(sm_szChk)chk[sm_szChk-1]->setChecked(false);
		fsizeCombo0->setEnabled(sw<12);
		fsizeCombo1->setEnabled(sw>10);
		sm_szChk=sw-9;
		}
	   else {
		sm_szChk=0;
		fsizeCombo0->setEnabled(false);
		fsizeCombo1->setEnabled(false);
		}
	break;
case 13 :
case 14 :
case 15 : if(sm_tmChk!=sw-12){
		if(sm_tmChk)tmChk[sm_tmChk-1]->setChecked(false);
		earlyDateTime->setEnabled(sw<15);
		lateDateTime->setEnabled(sw>13);
		sm_tmChk=sw-12;
		}
	   else {
		sm_tmChk=0;
		earlyDateTime->setEnabled(false);
		lateDateTime->setEnabled(false);
		}
	break;
case 19 : userCombo->setEnabled(sm_user=!sm_user);
	break;
case 20 : groupCombo->setEnabled(!sm_group);
case 21 :
case 22 : // _Params[sw]=!_Params[sw];
//	break;
case 24 : // kwCodecCombo->setEnabled((_Params[25]&&_Params[26])||TDSAct->isOn());
case 25 : // kw word
case 23 : goto _Jmp_;	
case 26 : // kw reset
	replAct->setEnabled(sm_reset);
	searchCutAct->setEnabled(sm_reset);
_Jmp_:	_Params[sw]=!_Params[sw];
	break;
case 27 : _Params[27]=!_Params[27];
	kwfind->setText(QString::fromUtf8( _smwdg_[_Params[27] ? Int_TDScript : Int_findChs]));
	kwfind->setPaletteForegroundColor(_Params[27] ? 0x000090 : 0x000000);
	break;
case 18 : showTop(filesor);
	break;
case 28 : {
	showTop(filesor);
	it=(LVItem *)_vList->currentItem();
	char *pt, *ptxt=strdup(it->fnam);
	i=listViewIndex(_vList, it);
	if(S_ISDIR(sm_pms[i].opt.mode)==0){
		pt=strrchr(ptxt, '/');
		if(pt!=ptxt)*pt=0;
	}
	filesor->seekPath(ptxt);
	free(ptxt);
	break;
	}
case 7 :	menulst.resetMem(NULL);
	break;
case 8 : if( (it=(LVItem *)_vList->currentItem()) ){// attrib
	FileAttrib  *fRslt=(FileAttrib  *)zalloc(sizeof(FileAttrib));
	fRslt->inView=2;
	const char *fn= it->fnam ;
	t=stat64(fn, &fRslt->sb);
	fRslt->lostLnk=( t && access(fn, F_OK));
	fRslt->fn=(char *)fn;
	fRslt->isDir = t ? false : S_ISDIR(fRslt->sb.st_mode);
	fRslt->sels.copy(fsels);
	FileAtt *attDlg=new FileAtt(this, fRslt);
	attDlg->execu( 400, fRslt->isDir ? 468 : 436, 2);
	}
	break;
case 29 : _vList->selectAll(true);
	break;
case 3 :  // vdel
	if( smThread==2 )quitThread();
	LVItem *nx;
	it=(LVItem *)_vList->firstChild();
	while(it){
	    nx=(LVItem *)it->nextSibling();
	    if(it->isSelected()){
		waitMsg=true;
		--shwCnt;
		removeItem(it, listViewIndex(_vList, it));				// fsels.rem(i--);
		waitMsg=false;
		}
	    it=nx;
	}
	break;
case 30 : if(deleting==false){
	  deleting=true;
	  FastBlock dels(fsels);
	  int j, cn=dels.memDiv(NULL);
	  t=0;
	  if( smThread==2 )quitThread();
	  i=0;
	  while( i<cn ){
	      tms=0;
	      if( t!=AllDel && sureDelete==false){
		t=infoWidget( dels.lstIndex(i), NULL, cn-i>1 ? delsInfo : delInfo, this);
		switch(t){
		case NoDel : continue;
		case CancelDel :
		case NO_BTN_ID : // click closeBox in title or Esc
			goto _ex_del_;
		}
	        }
	  _delFile(this, dels.lstIndex(i));
	  LVItem *it=(LVItem *)_vList->firstChild(), *nx;
	  for(j=0; j<sm_cnt; j++){
		nx=(LVItem *)it->nextSibling();
		if(strcmp(dels.lstIndex(i), sm_pms[j].fnam)==0){
			waitMsg=true;
			--shwCnt;
			removeItem(it, j--);
			waitMsg=false;
			goto _out_;
			}
		it=nx;
		}
	  _out_: i++;
	  }
	}
	_ex_del_: deleting=false;
		tms=20; // chSelect();
	break;
case 6 : {
	char *fsr=catstr(pluzonecwd, "searchResult.txt",'/');
	FILE *fp=fopen(fsr, access(fsr, F_OK) ? "w":"a");
	if(fp){
/*	time_t tm;QDateTime dt;time(&tm);dt.setTime_t(tm);*/
	  QCString s(QDateTime::currentDateTime().toString(sm_dtfmt).utf8()+noEncode+__div);
	  fwrite(s, s.length(), 1, fp);
	  it=(LVItem *)_vList->firstChild();
	  while(it){
		fwrite(it->fnam, strlen(it->fnam), 1, fp);
		fwrite(__div, 1, 1, fp);
		it=(LVItem *)it->nextSibling();
		}
	  fwrite(__div, 1, 1, fp);
	  fclose(fp);
	}
	free(fsr);
	}
	break;
case 5 :
case 32 : filesor->selectAsSrc(fsels, sw!=32);
	break;
case 33 : fsels.memDiv(NULL);	i=0;
	while( i<fsels.count() )
		filesor->doProEdit(strdup(fsels.lstIndex(i++)), menuClickStat&Qt::ControlButton);
//	menuClickStat=0;
	break;
case 38 :
case 35 :
case 36 :
case 37 : filesor->execProg(sw, &fsels, _uo[1].payload.i);
	break;
case 42 :
case 34 : { // sort
	int  idx, Sort=_uo[1].payload.i-( sw!=56 ? 0 : 60000);
	if(Sort>=_vList->columns())break;
	if(smThread==2)quitThread();
	LVItem *it=(LVItem *)_vList->firstChild();
	struct sm_params tmp;
	char *pt1, *pt2;
	bool Case=(bool)pms_case;
	_vList->header()->setSortIndicator(Sort, sortA=!sortA);
	if(Sort>1)Sort=smUseCols[Sort-2]+1;
	for(i=0; i<sm_cnt; i++){
	  idx=i;	//opt=&sm_pms[idx].opt;
	  for( t=idx+1; t<sm_cnt; t++){
	    switch(Sort){
	    case 0 : if( (namcmp(strrchr(sm_pms[idx].fnam, '/')+1, strrchr(sm_pms[t].fnam, '/')+1, Case)>0) == sortA )idx=t;
		break;
	    case 1 : pt1=strrchr(sm_pms[idx].fnam, '/');
		*pt1=0;
		pt2=strrchr(sm_pms[t].fnam, '/');
		*pt2=0;
		if( (namcmp(sm_pms[idx].fnam, sm_pms[t].fnam,Case)>0) == sortA )idx=t;
		*pt1='/';	*pt2='/';
		break;
	    case 2 : if( (sm_pms[idx].opt.siz>sm_pms[t].opt.siz)== sortA)idx=t;
		break;
	    case 3 : if((sm_pms[idx].opt.mtm>sm_pms[t].opt.mtm)== sortA)idx=t;
		break;
	    case 4 : if((sm_pms[idx].opt.atm>sm_pms[t].opt.atm)== sortA)idx=t;
		break;
	    case 5 : if( (namcmp(sm_pms[idx].opt.uName, sm_pms[t].opt.uName, Case)>0) == sortA )idx=t;
		break;
	    case 6 : if( (namcmp(sm_pms[idx].opt.gName, sm_pms[t].opt.gName, Case)>0) == sortA )idx=t;
		break;
	    case 7 : if((sm_pms[idx].opt.mode>sm_pms[t].opt.mode)== sortA)idx=t;
		break;
	    case 8 : if( (namcmp(sm_pms[idx].opt.type, sm_pms[t].opt.type, Case)>0) == sortA )idx=t;
		}
	  }
	  if(idx!=i){
	    tmp=sm_pms[idx];
	    sm_pms[idx]=sm_pms[i];
	    sm_pms[i]=tmp;
	  }
	  vInsertItem(_vList, sm_pms[i].fnam, SM_Sort,
		grapSizLmt, smUseCols, sm_dtfmt, NULL, it);
	  it=(LVItem *)it->nextSibling();
	}
	}
	break;
case 41 : filesor->doProEdit(menulst.lstIndex(_uo[1].payload.i), menuClickStat&Qt::ControlButton);
//	menuClickStat=0;
	break;
case 44 :	// stopAct
	smThread=0;
	break;
case 9 : smThread=-3;  // closeAllWdgSlot
	break;
case 16 : // quitThread(); //
//	close();
	smThread=-2;
	break;
case 31 : 
	showLog(filesor, smLogList, findLogImg, smLogListChs);
	break;
case 40 : if(proEditList.count())showTop( proEditList.at(0) );
	break;
case 45 : if(tabs->currentPageIndex()==1 && _vList->currentItem()){
	_vList->clearSelection();
	p_renam=strdup( ((LVItem *)_vList->currentItem())->fnam );
	_vList->currentItem()->startRename(0);
	}
	break;
case 46 : {
	LVItem *it=(LVItem *)_vList->currentItem();
	char *fn, *pt, *rn;
	struct stat64 st;
	fn=strdup(p_renam);
	pt=strrchr(fn, '/');
	*pt=0;
	rn=catstr( fn, strCodec->fromUnicode(it->text(0)) , '/');
	i=listViewIndex(_vList, it);
	sm_pms[i].mdf=true;
	if(strcmp(p_renam, rn)==0)free(rn);
	else if(isExist(rn, &st)==0){
		QApplication::beep();
		char *chs=catstr(rn, fnamExist,'\n');
		infoWidget(chs, warnChs, normError, this);
		free(chs);	goto _skp_;
	  }
	  else {
	     if(rename(p_renam, rn)){
		ErrorQuestion(this, normError, rn, renError );
	_skp_:	it->setText(0, pt+1);
		free(rn);
	    }
	    else {
		free(it->fnam);
		it->fnam=rn;
		sm_pms[i].fnam=rn;
	    }
	}
	sm_pms[i].mdf=false;
	free(fn);
	free((void *)p_renam);
	}
	break;
case 4 : fsplusLink(this, 5, 2/* newWidget */);
	break;
case 47 : {
	LVItem *it=(LVItem *)_vList->firstChild();
	operaListTag=!operaListTag;
	findAct->setIconSet(*pixmapLoad(operaListTag ? listFindImg : findImg));
	replAct->setIconSet(*pixmapLoad(operaListTag ? listReplaceImg : searchModifyImg));
	searchCutAct->setIconSet(*pixmapLoad(operaListTag ? listCutImg : searchCutImg));
	while(it){
		it->setType(operaListTag ? 0x00c000<<8 : 0);
		it->repaint();
		it=(LVItem *)it->nextSibling();
	}
	}
	break;
case 48 :
case 49 : moveListSet(optList, smColOpt, sw-48);
	break;
case 51 : if(listSet!=_uo[1].payload.ptr){
	    if(listSetMsg){
	        switch(smThread){
	        case 1 : waitMsg=true;
		break;
	        case 2 : quitThread();
	        }
	        adjListView(true);
	        waitMsg=false;
	        listSetMsg=false;
	   }
	}
	else {
		listSetMsg=true;
		orgDtfmtIdx=sm_dtfmtCombIdx;
		org_grapShow=sm_grapShow;
		org_SizLmt=grapSizLmt;
		}
	break;
case 50 : 
_skip2_:	sm_dtfmtCombIdx=(dtfmtCombo->count()-1)-dtfmtCombo->currentItem();
	sm_dtfmt=sm_dtfmtlst.lstIndex(sm_dtfmtCombIdx);
	dtfmtLab->setText(QString::fromUtf8(dtfmtChs)+QDateTime::currentDateTime().toString(sm_dtfmt));
	break;
case 43 : grapCombo->setEnabled( sm_grapShow=grapShowChk->isChecked() );
	goto _modulGraph_;
case 53 : // 53 - 55 don't change
	sm_grapSizIdx=grapCombo->currentItem();
	grapSizLmt=atoi(grapCombo->currentText());
	_modulGraph_ :  grapDemo(true);
	break;
case 54 :
case 52 : if(selAsSrc.count()){
	    LVItem *it=(LVItem *)_vList->currentItem();
	    if(it && it->isSelected())
		new CopyThread(this, filesor, selAsSrc, it->fnam, sw-52+FCOPY);
	}
	break;
case 55 : {
	CopyThread dirsum(this, filesor, fsels, NULL, EXE_COUNT);
	}
	break;
case 56 : filesor->popFspCons(((LVItem *)_vList->currentItem())->fnam);
	break;
case 57 : {
	SimpleImage *gse=new SimpleImage(filesor);
	gse->exe(strdup(((LVItem *)_vList->currentItem())->fnam));
	}
	break;
case 17 : {
	static const char cols[]={ 1,2,3,4,5,6,7, 1,1,0,1,0,1,0 },
	*pval=cols+colOptCnt;
	LVItem *it=(LVItem *)optList->firstChild();
	memcpy(smColOpt, cols, 2*colOptCnt);
	for(i=0; i<colOptCnt; i++){
		it->setType(pval[i] ? 0x207020<<8 : 0);
		it->setText(0, QString::fromUtf8(colName[ cols[i]-1] ) );
		it->setText(1, pval[i] ? "Yes" : "No");
		it=(LVItem *)it->nextSibling();
	}
	dtfmtCombo->setCurrentItem( (dtfmtCombo->count()-1) - 0);
	sm_grapShow=true;
	sm_grapSizIdx=3;	grapSizLmt=64;
	grapCombo->setCurrentItem(3);
	listSetMsg=true;
	grapDemo(true);
	goto _skip2_;
	}
	break;
default : return QMainWindow::qt_invoke(_id, _uo);
}
return true;
}

#ifndef QT_NO_PROPERTIES
bool SearchModify::qt_static_property( QObject* , int , int , QVariant* ){ return false; }
#endif // QT_NO_PROPERTIES

void SearchModify::customEvent(QCustomEvent *e)
{
int sw;
switch(sw=e->type()){
case Event_Error : for(int i=0; i<filesors.count(); i++)
			filesors.at(i)->getSMW()->smLogListAct->setEnabled(true);
	return;
case Event_AddItem : {
	struct sm_params *pms=(struct sm_params *)e->data();
	while(waitMsg)usleep(1000);
	insertList(pms, operaListTag ? LO_SM_Add : SM_Add);
	free(pms);
	if(smThread<1)setResult();
	}
	return;
case virtual_notify : {
	runSearch=true;
	LVItem *it=(LVItem *)_vList->firstChild(), *nx;
	int i, rt;
	bool lnk;
	struct stat64 st;
	for(i=0; i<sm_cnt&&smThread==2; i++){
	    nx=(LVItem *)it->nextSibling();
	    rt=lstat64(sm_pms[i].fnam, &st);
	    if(rt){ // lstat can read lostlink-file
		if(sm_pms[i].mdf==false)removeItem(it, i--);
	    }
	    else {
		lnk=S_ISLNK(st.st_mode);
		if(stat64(sm_pms[i].fnam, &st)==0){
		ListOptions *opt=&sm_pms[i].opt;
		  if( opt->isLnk!=lnk || (S_ISDIR(st.st_mode)==0&&opt->siz!=st.st_size) || opt->mtm!=st.st_mtime || opt->mode!=st.st_mode || opt->uId!=st.st_uid || opt->gId!=st.st_gid){
		    ListOptions optbuf;
		    optbuf.isLost=false;	optbuf.isNoRead=false;
		    setListOption(&optbuf, st, lnk, S_ISDIR(st.st_mode) ? subDirCount(sm_pms[i].fnam) : 0);
		    vInsertItem(_vList, sm_pms[i].fnam, SM_Notify,
			grapSizLmt, smUseCols, sm_dtfmt, &optbuf, it);
		    sm_pms[i].opt=optbuf;
		  }
		}
	    }
	    it=nx;
	}
	if(smThread==2)smThread=0;
	runSearch=false;
	return;
      }
case ErrorQ :
case CopyQuest : {
	struct infowdg_params *pms=(struct infowdg_params *)e->data();
	pms->ret=infoWidget(pms->dst, pms->cap, pms->info_id, CopyQuest && panelStatus==1 ? (QWidget *)cpThrPanel : this);
	pms->hold=false;
	}
	return;
case 65040 : _delFile(this, (const char *)e->data());
	free(e->data());
	break;
case 65119 :  cpThrPanel=new CopyPanel(filesor, sbar); // (NULL, NULL,WX11BypassWM);
	cpThrPanel->execu(this);
	break;
case 65109 : { // cp over ?
	del_params *delpms=(del_params *)e->data();
	delpms->ret=_delFile(this, delpms->fn);
	delpms->hold=false;
	}
	break;
case 65130 : {
	char *info=copyInfo(copyMode, copyResult, cpSzM, copySize, take);
	sbar->showMsg(info, 99);
	free(info);
	}
}
cpEvent=false;
}

