/*
    林江华编写，2010-2月，Copyright LinJiangHua
    Free under LGPL 2-2010
   email: xempo@189.cn
*/

#ifndef    FILESAN
#define    FILESAN

#include <qmainwindow.h>
#include <qaction.h>
#include <qlabel.h>
#include <qheader.h>
#include <sys/errno.h>
#include <qmetaobject.h>
#include <private/qucomextra_p.h>
#include <qtextcodec.h>
#include <qdatetime.h>
#include <qtimer.h>
#include <qsplitter.h>
#include "stdfun.h"
#include "helpwdg.h"
#include "imagefileview.h"
#include "treeview.h"
#include "combo.h"
#include "libnorm.h"
#include "actmenu.h"
#include "proedit.h"
#include "copy.h"
#include "basewidget.h"
#include "xfunc.h"

extern const QUMethod  slot_ptr, slot_int, slot_0_0;
extern const QMetaData clearBrwSlot, clearPESlot, menuOpenSlot,
	menuBrowSlot, chSelSlot, newSlot, dbclickSlot, enterSlot, doRenSlot,
	attribSlot,	toggRenSlot,	asSrcSlot,	addSrcSlot,
	selAllSlot,	deleteSlot,  sortSlot, sortAccelSlot,
	fspZoneSlot, sImageSlot,
	openSlot, opensSlot;

enum fun_num {
	SelectAsSource=5, SelectAction=36, ChangItem=37, IcoViewMous=38,
	DbClick=39, KeyEnter=40, exeOpen=41, exeOpens=42
	};

#include "fsloop.def"

#define	ReadComm(msg)	((msg&~COMBENTER) & 0xffff)

class QPushButton;
class QToolButton;
class SearchModify;
class FspCon;

struct dirpost_params {
const char *dnam;
const QPixmap *pix;
int est;
};

struct movepost_params
{
const char *src;
bool isDir;
int info, mvdup;
};

#define  lineCnt  3
class Filesan : public QMainWindow
{
friend class TreeView;
friend class CopyThread;
friend void *subExpand(void *);
 moc_Object

public:
Filesan(QWidget *parent, int initRt);
// ~Filesan();
void exec(char *dnam);
int getItemAttrib(bool isViewOpera, bool sub);
void popRightMenu(void *it, bool isView);

void fspRightMenu(void *it, bool isView);

void updatePluzone(bool isComb);

char *itemFullPath(const void *ico);
void setObjsStat(int tag, bool isView);
void setCopyStats(const char *chs);
int doProEdit(const char *pt, bool mult, int pos=0, const char *fun=NULL);

void popFspCons(const char *fnam);

void refreshList(const char *fmt);
void chFattrib(struct fAttribRslt *fr);
void imageInfo();
void treeUpdateObjs(char *pth);

void processImage(const char *pth, FastBlock *file_lst, ListOptions *f_mode);

LVItem *getItem(const char *);
void showFspInfo(fsp_dir *);

void busiedCursor();
void normalCursor();

void addTag(const char *dn);

void setNotifyTimer(); // inline

QString _toUnicode(const char *txt) const
	{ return vStrCodec->toUnicode(txt); }

SearchModify *getSMW() const
{ return search_mdf_wdg; }

void setSMW(SearchModify *w){ search_mdf_wdg=w; }

void browNumb(FspCon *wdg); // inline for proEdit

void openSelect(const char *pth, const char *nam);

void setFilter(const char *f){ Filter=f; }

int getModul() const
{ return modul; }

StatusPanel *stBar() const
{ return sbar; }

int dirsCount() const
{ return vDirCnt; }

char *getDirNam() const
{ return dirNam; }

TreeView *getTreeView() const
{ return treeview; }

void setLib(fsp_lib *fsp);

void showMountInfo(LVItem *it);

FastBlock *getFSels()
{ return &fsels; }

void selectAsSrc(FastBlock &lst, bool add);
void execProg(int sw, FastBlock *sel, int idx);

void bwResize(QWidget *bw);

int getFd() const
{ return notifyFP->_fileno; }

void delLVItem(LVItem *it, int val=1);

void setFsptm(int v){ fsptm=v; }

void setProgFonts(const QString &fn, const char *sz, bool bold, bool italic, bool underline);

inline void newText(const char *pth);

inline void setFspCons(FspCon *p)
{
fspZone=p;
fspX=p;
}

void addNumb(fsp_dir *pdir, BYTE *unit, bool SH/* show hide */);

void seekPath(const char *pth);

void fsKillTimer();
void fsStartTimer(){ if(prgTmId==0)prgTmId=startTimer(500); }

void objsUpdate();

int  operaState(struct stat64 *st);

int getCDM() const
{ return CurDirMode; }

void clearView();

ActMenu *getTagMenu() const
{
return tagMenu;
}

protected:
bool event( QEvent *e );
virtual void customEvent(QCustomEvent *);

private:
const QPixmap **freqPix;

#define  freqDPix(Sym)  freqPix[ (Sym&1023) <3  ? (Sym&1023)+DIR_OFF : Sym&1023 ]
#define  _freqDPix(Sym)  freqPix[ 3+((Sym&1023) <3  ? (Sym&1023)+DIR_OFF : Sym&1023) ]

void updateDrivers();

void runFilesan(char *chs);

int setCWD(const char *pth, int msg,  LVItem *it=NULL);

void closeFspList();

LVItem **deleteItems;
int it_pre, it_cnt;

IVItem **deleteIcons;
int ico_pre, ico_cnt;

int  vispos;
LVItem	*focusIt;
IVItem *focusIco;

QTimer *notifyTimer;
void dirNotify(const char *dnam);
FILE *notifyFP;

// treeview->seekDir(const char *path, int sw, const char *dst=NULL, int typeIco=0);
void subDirs(const char *dn, LVItem *dirIt, int msg/* not thread */);

void mainViewCWD(char *dn, bool isComb);

void setDirNoSort();

void viewRemove(const char *dnam, FastBlock *fvp_lst, ListOpera *fvp_lo, int i, int cnt_dir, bool isdir);

void updatePathComb(char *fdirnam);

void IdSelects();

int *_Params; // consrtuct init on here order !!!

int cursorTimes, navBtn, DelTag,
	modul, // 0 is dirview; 1 place; 2 ...;
	itemDel,  iconDel,
	disktime,  showTm,
	wheel_tm,  tagCount,	init_rt, 
	_viewCodec, defCode, bakCodec, ar_engIdx,
	vNotifyTM, colIdx, listview_sort, iconview_sort;

const char *homeUnder, *homeName,
	*Filter, *curItemTxt;
char  *dirNam,
 RootStat[2],  *oldName; // use for rename

const int u_id, g_id;
int renId, renCase0Id, renCase1Id, oldId, caseId,
	dirNoSortId, showHideId,
	fspccmpId, ccmpId, dccmpId,
	prgTmId, langId;

/* ____________copy______________
int copyResult, copyMode, copiedTimes;
unsigned long copySize, cpSzM;
time_t cp_tm, take;
bool stopCopyForExit;
________________________________*/

bool   brwImg, sort_ascend,
	showHide, newMsg, fspTag, thrImg,
	vNotifyMsg,runVnotify, vNotifyTog,notifying,
	runImg,	tmDoing;

WId vDir, mbwId, vfspId;

SearchModify *search_mdf_wdg;
FspCon *fspZone;

void freshDirItem(LVItem *any /*, bool*/);
void sortView(int n);

void modulsInit(bool init);

int PreCopyStats(int c=0);

void changButton(QAction *btn, const char *chs, int c, bool able);

void runStatus();
void creatMultPanel(QRect *r);
QRect multRect, curViewRect;

QSplitter *one, *mainSplit, *multfunPanel, *fspView;
BaseWidget *mainBW, *dirBW;
void multPanelResize(BaseWidget *bw);

void leavePlace();
TreeView *treeview;
ListContent *_filelist, *_fsplist;
ImageFileView *_iconview;
QScrollView *creatIconView(QWidget *wdg, int sw=0);
QScrollView *currentView();
char *currentItemPath();
char *curSelItemPath();

FastBlock  fsels, Idsels,
pdklst, dno_dir_lst, dno_file_lst;

ListOpera dno_d_lo, dno_f_lo;

void renaming(char *pt, int vw, bool pop=false);

int deleteLV(const char *nam);
int deleteIV(const char *nam);

int delIV(IVItem *ico, int val=1);
int delLV(LVItem *it, int val=1);

Combo *pathComb;

int vFileCnt, vDirCnt, CurDirMode;

QLabel *statPanel;
QFrame *lines[lineCnt];
void setFSInfo();
bool isViewOpera();
char *listFullPath(LVItem *it);
char *viewFullPath(IVItem *it);
void procSelects();
void creatAccount(const char *pdir, int img, QString &str, FastBlock *plst, int id);
void personsMenu(ActMenu *menu, const char *dn, int img, FastBlock &lst, int (*fun)(fsp_dir *pdir, fsp_dir *dir));

fsp_lib *cfsp;

bool isFspOpera();

bool isFsp(const char *fnam, bool show);

void creatFspList();
int fsptm;

int idxIcon;
void **pIcon;

// isView : >0 View, 2 is recover; 0 tree; 
//return : 0 ok,  -1 false, 2 cancel
int  delFile(void *it, int isView, int id);

char *createObj(const char *pth, int sw);

void setPathComb(const char *pth);

// bool runImg;
void holdWait();

void freshView(const char *dirname, bool eXe, FastBlock *dir_lst, ListOptions *d_mode,
	FastBlock *file_lst, ListOptions *f_mode);
void createTree(const char *fdirnam, FastBlock *dir_lst, ListOptions *d_mode, int msg, LVItem *Parent);

QTextCodec *vStrCodec;

const QPixmap *idPix;
struct stat64 statbak;
int filePixmap(const char *fn);
QToolButton *treeDescendBtn, *fastTagsBtn, *placeBtn, *fsplusBtn, 
*multPanelBtn, *panelRightBtn, *toolPanelBtn,
*reFreshBtn, *listBtn, *browImageBtn, *onlyFileBtn, 
*summBtn, *operaBtn, *settingBtn, *codecBtn, *tagBtn, *personBtn,
*_multPanelBtn, *_list, *_browImg, *_onlyFile,
*creatPB(QWidget *wdg, int Img, const char *tips, QObject *, const char *slot, bool togg, bool on, int key=0);

QAction *parentDirAct, *homeAct, *backDirAct, *nextDirAct,
 *cp2dirAct, *mv2dirAct, *deleteAct,
 *selectDoneAct, *selectAddAct, *selAllAct,
 *proEdit2Act, *proEditAct, *simpleImageAct, *propertiesAct, *dirSumAct,
 *copyAct, *fdupAct, *moveAct, *linkAct,
 *genArchAct, *fspArchAct,
 *cpLogAct;
QAccel  *sort1Acc;
StatusPanel *sbar, *topSbar;
QToolBar *topBar, *bottomBar;

ActMenu  *summaryMenu, *tagMenu, *operaMenu, *confMenu, *personMenu,
	*newMenu, *stocksMenu, *lifeMenu;
QPopupMenu *codecMenu, *subCode, *langMenu, *ccmprsMenu, *fspccmprsMenu;
void setFonts(const QFont & fnt);
LVItem *rootItem;
IVItem *renIco;
};

extern QPtrList <Filesan> filesors;

extern FastBlock langlst, stockslst, lifelst;

extern fsp_dir *FileAssoc;
extern QListView *cpListView;

extern const char pluzone[],	slot_addtag[],
 	sig_chsel[],		slot_chsel[],
	sig_chIcoCur[],	slot_chIcoCur[],
	sig_mous[],	slot_mous[],	slot_closall[],
	slot_newDir[],	slot_multPanel[],
	_Spc[], clickSig[],		slot_vEnter[],
	sig_activated[],  slot_sortAccel[],
	sig_dbclick[],	slot_dbclick[],
	slot_about[],  slot_copyright[],
	slot_open[],	slot_addSrc[],
	slot_asSrc[], slot_ren[], slot_del[],
	slot_selall[],	slot_attrib[],
	slot_list[],	slot_imgbrw[],	slot_onlyfile[],
	slot_dsum[], slot_cp2dir[], slot_mv2dir[];

extern const char **colName, **cpListCols;
extern const char *p_dtfmt;
extern char *colOptRslt, useCols[colOptCnt];

extern int sysCmdId,
	comD, inputH;

enum ListColOpt {sizeOpt, mtimeOpt, atimeOpt, usrOpt, groupOpt, attribOpt, typeOpt };
enum sureDelRlt {SureDel, NoDel, AllDel, CancelDel };

#define  is_rTag(m)  ((m&ICO_NOREAD)==0)

extern const QPixmap *selectTagPix(int Sym);

extern const char AlphChs[];

extern void loadSearchModify(Filesan *fs);

extern QScrollView *creatFileList(QWidget *wdg, void *ptr, const char *cols, char *use_cols, int sw);

#define  isHideDir(pt)  strstr(pt, "/.")
#define  isDirList(pt) ( modul!=NO_MULT_PANEL && isHideDir(pt)==NULL)

#define		ini_slot_cnt   4
#define		_iconview_slot_cnt  7

extern QToolButton *menuButton(int img, const char *txt, QToolBar *tb, QPopupMenu *menu, int key);

extern const char *_filelistSig[ ini_slot_cnt ], *_filelist_slots[ ini_slot_cnt ];

#endif
