/*
	Wrtie by xempo 2015
	Free under LGPL
*/

#include <qtoolbutton.h>
#include <qcursor.h>
#include "conspace.h"
#include "infor.h"
#include "dlist.h"
#include "jxswitch.h"
#include "fsptime.h"
#include "write.h"
#include "shellcom.h"

#include "fspcon.h"
#include "filesan.h"
#include "../rtdata/en/target/filesor.h"

const QPixmap *_idPix;

void Filesan::fspRightMenu(void *it, bool isView)
{
ActMenu menu(this), newFsp(this), popMenu(this);
menu.setFont(font());
newFsp.setFont(font());
if(it){
	menu.insertMenu(-1, renChs, this, slot_ren, Key_F2);
	menu.insertMenu(itemRemImg,  delIdChs, this, slot_del, Key_Delete);
	if(isView){
		menu.insertMenu(proEditImg, editIdChs, this, SLOT(proEdit()), Key_F6);
		menu.insertMenu(-1, chmodeChs, this, SLOT(chmod()), 0);
		menu.insertMenu(-1, chtimeChs, this, SLOT(chtim()), 0);
	}
	else {
		menu.insertMenu(attribImg, attribChs, treeview, SLOT(fspAttr()), 0);
		menu.insertMenu(closeImg, closeFspChs, treeview, SLOT(closeFsp()), 0);
	}
	menu.insertSeparator();
}
if(it||isView){
	newFsp.insertMenu(newDirImg, new_DirChs, this, slot_newDir, CTRL+ALT+Key_N );
	newFsp.insertMenu(newDirImg, newZDirChs, this, SLOT(newZDir()), ALT+Key_N );
	newFsp.insertMenu(IdImg, newId, this, SLOT(new()), CTRL+Key_N );
	menu.insertItem(*pixmapLoad(newImg), QString::fromUtf8(newChs), &newFsp);
}
if(isView==false){
	menu.insertSeparator();
	popMenu.lstCreatMenu(this, slot_openfsp, slot_clearfsp, fspSpaceImg, &menuPlus);
	popMenu.insertMenu(fspZoneImg, fspconChs, this, SLOT(FspCon()), 0);
	menu.insertItem(*pixmapLoad(fsplusImg), QString::fromUtf8(recentFspChs), &popMenu);
	}
menu.exec(QCursor::pos());
}

fsp_lib *lastWS()
{
int i;
for(i=SPACELIMIT-1; i>-1; i--)if(workspace[i])return workspace[i];
}

void Filesan::popFspCons(const char *fnam)
{
OpenSpace msg;
fsp_lib *lib;
if(fspZone&&fspZone!=(FspCon *)this){
	showTop(fspZone);
	msg=OpenSpace(RScript|CompactMsg|FspError|OpenLastDir);
}
else {
	fspZone=new FspCon(this);
	fspZone->exe();
	msg=(OpenSpace)(RScript|FspError|OpenLastDir);
}
fsptm=0;
if(fnam&&fnam!=pluzone){
	Fsp_Zone=fspZone; // for descript
	lib=fspSpace(fnam, msg, -1);
}
else lib=NULL;
if(cfsp)cfsp=testFsp(cfsp);
if(cfsp==NULL&&modul==_FSPLUS){
	cfsp=treeview->itemFspRoot((LVItem *)treeview->currentItem());
	treeview->setSelected(treeview->currentItem(), true);
	}
if(lib==NULL){
	if(cfsp)lib=cfsp;
	else lib=lastWS();
	}
treeview->setRecent(lib);
fsptm=6;
fspZone->updateZone(lib);
if(fnam==pluzone){
	scopy(InpBuf, "workspace");
	lock=-1;
	comRun(lib, InpBuf, 0, NULL);
	lock=0;
	}
}

void Filesan::showFspInfo(fsp_dir *dir)
{
if(dir){
	char buf[300];
	fspInfo(dir, buf);
	topSbar->showMsg(buf, 0, 1, 0x4747a2);
	pdInfo(dir, buf);
	sbar->showMsg(buf, 0, 1, 0x135013);
}
}

void Filesan::IdSelects()
{
   LVItem *item=(LVItem *)_fsplist->firstChild();
   Idsels.resetMem(NULL);
   while( item ){
	if( item->isSelected() )Idsels.add( item->fnam );
	item=(LVItem *)item->nextSibling();
      }
}

LVItem *Filesan::getItem(const char *txt)
{
   LVItem *item=(LVItem *)_fsplist->firstChild();
   int i;
   const char *pt;
   while( item ){
	pt=item->fnam;
	for(i=0; txt[i]==pt[i]; i++); 
	if( txt[i]==0 && (pt[i]|32)==32 )return item;
	item=(LVItem *)item->nextSibling();
      }
   return NULL;
}

void Filesan::closeFspList()
{
fsplusBtn->setOn(false); 
topSbar->showMsg(NULL);
sbar->showMsg(NULL);
delete fspView;
_fsplist=NULL;
}

void Filesan::creatFspList()
{
const char **idCols=_filesor_+Int_IdCols1;
 int i, h=mainBW->height();
 fspView=new QSplitter(mainSplit);
 vfspId=fspView->winId();
 _fsplist=new ListContent(fspView, fspListChs, T_FspList, this);
 _fsplist->setSorting(-1);
 _fsplist->setSelectionMode(QListView::Extended);
 _fsplist->setRootIsDecorated(true);
 if(_idPix==NULL)_idPix=new QPixmap(*pixmapLoad(IdImg));
 idPix=_idPix;
 for(i=0; i<4; i++)
	_fsplist->addColumn(QString::fromUtf8(idCols[i]));
 _fsplist->setColumnAlignment(1, Qt::AlignRight);
 mainSplit->setResizeMode(fspView, QSplitter::KeepSize);
 fspView->show();
 for(i=0; i<ini_slot_cnt; i++)connect(_fsplist, _filelistSig[i], this, _filelist_slots[i] );
// connect(vlst, sig_chcur, this, SLOT(test()) );  次序不同iconview，先currentChange
 connect(_fsplist->header(), SIGNAL(clicked(int)), this, SLOT(Sort(int)) );
 treeview->selectFspDir(); // select currentItem()
}

void Filesan::addNumb(fsp_dir *dir, BYTE *unit, bool SH/* show hide */)
{
static const char fmt[]="%d ",
	rwm[]="rwhoABGL"; // like dlist.c
int nmb=FCU_Numb(dir, unit);
BYTE mode;
if(*unit==1 && (SH || ((mode=unit[1])&FSP_MH)==0) ){
	char buf[32];
	unsigned int len=0, L;
	int  i,color;
	LVItem *sit=NULL, *it=(LVItem *)_fsplist->firstChild();
	while(it&&it->nextSibling()){
		if(atoi(it->fnam)==nmb)return;
		it=(LVItem *)it->nextSibling();
	}
	if(it&&atoi(it->fnam)==nmb)return; // must do	
	sprintf(buf, fmt, nmb);
	it=new LVItem(_fsplist, it, buf);
	it->setPixmap(0, *idPix);
	if(mode&FSP_OEM)color=0x901313<<8;
	else {
		color=0;
		it->setRenameEnabled(2,true);
		if(mode&FSP_MW){
			it->setRenameEnabled(0, true);
			it->setRenameEnabled(3,true);
			if(mode&FSP_MR)color=0x000099<<8;
		}
		if((mode&FSP_MR)==0)color=0x106810<<8;
		}
	if(color)it->setType(color);
	for(i=0;i<dir->DAUC;i++){
		L=*(int *)( pFcuDauPos( dir, unit, i )+sizeof(int) + sizeof(int) );
		len+=L;
		if(dir->DAUC>1){
			sprintf(buf, fmt, i);
			sit=new LVItem(it, sit, buf);
			sprintf(buf, fmt, L);
			sit->setText(1, buf);
		}
	}
//	getSize(dir,unit, len);
	sprintf(buf, fmt, len);
	it->setText(1, buf);
	L=paraExpre(unit[1], buf+1, rwm);
	*buf=32;	buf[L+1]=32; buf[L+2]=0;
	it->setText(2, buf);
	it->setText(3, fspAscTim(FCU_GetDate(unit) ) );
	}
}

