/*
  林江华编写，2009-2010, 2014
  Free under LGPL
*/

#include <qtextbrowser.h>
#include <qfile.h>
#include <qcheckbox.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qcursor.h>
#include <qclipboard.h>
#include "filesan.h"
#include "xfunc.h"
#include "pluzone.h"
#include "inputdlg.h"
#include "helpwdg.h"
#include "fspcon.h"
#include "ProEdit/proedit.h"
#include "calc.def"
#include "../rtdata/en/target/filesor.h"
#include "../rtdata/en/target/help.h"
#include "statuspanel.cpp"

FastBlock  selAsSrc;

extern QMetaData popPluzoneSlot,
	findSlot,	find2Slot;
extern const char slot_find[], slot_find2[]; // searchmodify.h

enum BrowsWdg { BROWSNUMB, BROWSHTML };

const char helpwdg[]="Help", slot_proedit[]=SLOT(proEdit()),
	**_help_=(const char **)helpwdg,
	**p_fspBtnCap=_help_,	**p_browBtnCap=_help_;

#define	 __from_unicode(s) strCodec->fromUnicode(s)

CustEvents::CustEvents(int T) : QCustomEvent( T )
{
}

void showLog(Filesan *fs, QStringList &msgList, int img, const char *cap)
{
HelpWdg *wdg;
if( (wdg=isActive(img))==NULL ){
	wdg=new HelpWdg(fs, 0);
	wdg->setNumb(img);
	wdg->setCaption(QString::fromUtf8(cap));
	wdg->setIcon(*pixmapLoad(img));
	wdg->show();
}
QString s;
for(int I=0; I<msgList.count(); I++)s+=*msgList.at(I)+"\n";
wdg->getBrowser()->setText(s);
}

QPtrList <HelpWdg> helpList;

void showTop(QWidget *wdg)
{
// if(wdg->isHidden())wdg->show();
if(wdg->isMinimized())
	wdg->showNormal();
else {
	wdg->raise(); wdg->setActiveWindow();
 }
}

inline void HelpWdg::showMessage(const char *msg)
{
sbar->showMsg(msg, 99);
}

HelpWdg *isActive(int numb)
{
int i;
HelpWdg *hlp;
for(i=0; (hlp=helpList.at(i)); i++)if(hlp->getFileNam()==0 && hlp->getNumb()==numb){
	showTop(hlp);
	return hlp;
}
return NULL;
}

bool browsHtml(QWidget *P, const char *fn, bool mult)
{
bool has=false;
int i, num=-1;
HelpWdg *brows;
for(i=0; (brows=helpList.at(i)); i++)
	if( brows->getFileNam() && strcmp(brows->getFileNam(), fn)==0 ){
		has=true;
		if(num<brows->getNumb())
			num=brows->getNumb();
			// if(num==0)num++;
		if(mult==false){
			showTop(brows);
			brows->showMessage(hasLoaded);
		}
	}
num++;
if(mult||has==false){
	brows=new HelpWdg((Filesan *)P, BROWSHTML);
	brows->setNumb(num);
	brows->initForBrows(fn);
}
return true;
}

void fsplusLink(QWidget *par, int numb, int newWdg/* 2: 新建规 */)
{
if( (newWdg&2) && isActive(numb)==NULL ){
	HelpWdg *hlp=new HelpWdg((Filesan *)par,0);
	hlp->initForNumb(numb);
	}
else ((HelpWdg *)par)->fsplusBrows(numb);
}

bool fastBrows(QWidget *wdg, const char *prg, const char **fn)
{
static const char *prognam[2]={ "pluzone.html", "proedit.file" };
int i;
for(i=0; i<2; i++)
  if(strcmp(prg,prognam[i])==0){
	while(*fn){
	switch(i){
	case 0 : browsHtml(wdg, *fn, false);
		break;
	case 1 : ((Filesan *)wdg)->doProEdit(*fn, false);
		break;
	}
	fn++;
	}
	return true;
}
return false;
}

FastBlock *PrgList;
void ExecProg(QWidget *wdg, FastBlock *Progs, FastBlock *param)
{
int i, pCnt, cnt=param->count();
if(PrgList)delete PrgList;
PrgList=new FastBlock(*Progs);
pCnt=PrgList->memDiv(":");
char **prg=PrgList->plist(),	*lst[cnt+2];
for(i=0; i<cnt; i++)lst[i+1]=param->lstIndex(i);
lst[i+1]=NULL;
if(__params[38])for(i=0; i<pCnt; i++ )
	if( fastBrows(wdg, prg[i], (const char **)lst+1) )return;
	
if(fork()==0){
    for(i=0; i<pCnt; i++ ){
	lst[0]=prg[i];
	execvp(prg[i], lst ); /* 如果执行成功，则不返 */
	}
    _exit(1); // failed ! must stop this sub-fork
// _exit() 是系统调用，exit()是一个标准C函数（库)
}
}

const char NumSyb[]="#_numb_", otherWidget[]="#_target_";
void QTextBrowser::linkClicked(const QString &lnk)
{
QWidget *par1=parentWidget();
int numb, t;
const char *tmp=lnk; // no zh_CN etc
if(strstr(tmp, NumSyb)==tmp){
	FastBlock mlst(strdup(tmp+sizeof(NumSyb)-1), "_");
	numb=atol( mlst.lstIndex(0) );
	switch(numb){
	case 9999 : /* e-mail */
		mlst.rem(0);
		ExecProg(par1->parentWidget(), emailProg, &mlst);
		break;
	default : t=(mlst.count()>1 && stricmp("target", mlst.lstIndex(1))==0) ? 2 : 0;
		fsplusLink(t ? par1->parentWidget() : par1, numb, t );
	}
  }
else if(strstr(tmp, otherWidget)==tmp)browsHtml(par1->parentWidget(), tmp+sizeof(otherWidget)-1, false);
          else {
	((HelpWdg *)par1)->getBrowser()->setSource(lnk);
	menubrows.add(__from_unicode(lnk));
	par1->setCaption(lnk);
	}
}

void HelpWdg::fsplusBrows(int num)
{
if(isActive(num)==NULL){
  MAU send[2];
  char buff[80];
  int msg=numbRead( descript, num, send, 2, true);
  if(msg<0)sprintf(buff, noThusDat, num);
  brow->setText(QString::fromUtf8(msg>-1 ? send->buf: buff) );
  setCaption(QString::fromUtf8(msg>-1 ? send[1].buf : helpwdg) );
  _numb=num;
  if(msg>-1)freeMAU(send,2);
  }
}

static const char sbarName[]="statusBar", brows[]="brows";
HelpWdg::HelpWdg(Filesan *wdg, int T) : QMainWindow(wdg, T ? brows : helpwdg, WType_TopLevel|WDestructiveClose),
	_numb(-9), fileNam(NULL)
{
setFont(wdg->font());
helpList.append(this);
if(T){ // brow
_brwSz_: resize(screenWidth*4/5, screenHeight*4/5);
}
else {
	if(screenWidth<1023)goto _brwSz_;
	resize(screenWidth*3/4, screenHeight*3/4);
}

bar=new QToolBar(sbarName, this, Qt::DockBottom);
bar->setMovingEnabled(false);
sbar=new StatusPanel(bar, 2);
bar->setStretchableWidget(sbar);
brow=new QTextBrowser(this, T ? brows : NULL);
brow->setWrapPolicy(QTextEdit::AtWordOrDocumentBoundary);
// connect( brow, SIGNAL(linkClicked(const QString & link)), this, SLOT(recClicked()) );
setCentralWidget(brow);

if(_help_==(const char **)helpwdg){
	_help_=charsFromFSP(4);
	FastBlock chkCap((char *)fspBtnCap, "\n", AllNoFree),
		btnCap((char *)browBtnCap, "\n", AllNoFree);
	p_fspBtnCap=(const char **)chkCap.plist();
	p_browBtnCap=(const char **)btnCap.plist();
  }
}

void HelpWdg::initForNumb(int numb)
{
#define	BtnsCount	5
static const int Imgs[BtnsCount]={ aboutImg, pluzoneImg, emailImg, searchImg, fastFindImg },
	keys[BtnsCount]={ CTRL+Key_V, Key_F1, CTRL+Key_E, CTRL+Key_F, Key_F3 };
static const char *hlpslot[BtnsCount]={SLOT(help()),SLOT(pluzone()),SLOT(email()),slot_find, slot_find2/* findnext */};
setIcon(*pixmapLoad(aboutImg));
for(int i=0; i<BtnsCount; i++){
	creatTA(this, bar, Imgs[i], p_fspBtnCap[i], hlpslot[i],keys[i]);
	if(i==2)bar->addSeparator();
	}
_codec=-1;
fsplusBrows(numb);
show();
}

void QTextBrowser::highlighted(const QString &msg)
{
if(name() && strcmp(name(), brows)==0){
	((HelpWdg *)parentWidget())->showMessage(__from_unicode(msg));
	}
}

void HelpWdg::setTitle(const QString &fnam)
{
char buf[32];
if(_numb>0)sprintf(buf, " @ <%d>", _numb+1);
setCaption(fnam+ (_numb>0 ? buf : " @") );
}

void HelpWdg::initForBrows(const char *fn)
{
int i;
#define	BrowsBtnsCount	9
static const int imgs[BrowsBtnsCount]={  backImg, nextImg, homeImg ,refreshImg, dirOpenImg, proEditImg, codecImg, searchImg, fastFindImg },
	keys[BrowsBtnsCount]={ CTRL+Key_B, CTRL+Key_F, CTRL+Key_H, Key_F5, Key_F11, Key_F6, 0, CTRL+Key_F, Key_F3 };
static const char *browslot[BrowsBtnsCount]={SLOT(backward()),SLOT(forward()),SLOT(home()),
	SLOT(fresh()), slot_openpath, slot_proedit, slot_popCodecMenu, slot_find, slot_find2/* findnext */ },
	slot_enable[]=SLOT(setEnabled(bool));
setIcon(*pixmapLoad(htmlImg));
_codec=0;
QAction *a;
for(i=0; i<BrowsBtnsCount; i++){
	a=creatTA(i>2 ? this : (QWidget *)brow, bar, imgs[i], p_browBtnCap[i], browslot[i], keys[i]);
	switch(i){
	case 0 : connect( brow, SIGNAL( backwardAvailable(bool) ), a, slot_enable );
		a->setEnabled( FALSE );
		break;
	case 1 : connect( brow, SIGNAL( forwardAvailable(bool) ), a, slot_enable );
		a->setEnabled( FALSE );
		break;
	case 2 : 
	case 6 :  bar->addSeparator();

	}
}
brow->mimeSourceFactory()->setFilePath( "." );
const QString s(strCodec->toUnicode(fn));
brow->setSource(s);
if(QFile::exists(s)==false)brow->setText(QString::fromUtf8(incorrectDisplay));
show();
setTitle(s);
fileNam=strdup(fn);
menubrows.add(fn);
}

void HelpWdg::keysFunc(int k, int st)
{
  int  i, b;
  if( st==AltButton)switch( k ){
   case Key_F6 : // fast linkopen
		goto _lnk_;
   case 'B' :
   case 'O' :
   case 'U' :
	{
	char buf[80];
	switch(k){
	case 'B' :	if(_codec<0)b=strlen(brow->selectedText().utf8());
			else _setCodec(_codec)->fromUnicode(brow->selectedText(), b=0x20000);
		i=0;
		break;
	case 'O' :	b=brow->selectedText().length();
		i=1;	break;
	case 'U' : b=900000;	i=2;
		setargv((char *)(const char *)brow->selectedText(), ",;\\/\t \n", &b);
	}
	sprintf(buf, p_countChs[i], b);
	infoWidget(buf, NULL, countInfo, this);
	}
	break;
   case 'N' :
   case 'D' : {
		double d=calc(brow->selectedText());
		if(n_CalcErr)infoWidget(calcErr(), NULL, calcErrInfo, this);
		else {
			char buf[80];
			sprintf(buf, k=='N' ? "%g" : "%lf" , d );
			infoWidget(buf, NULL, countInfo, this);
		}
	}
     }
     else if(st==ControlButton)switch(k){
	case 'Q' : close();
		QApplication::postEvent(qApp, new QCloseEvent ); // 2 above pluzone must like thus
	//return true;
	}
	else switch(k){
	       case Key_F5 :
			if(helpList.count()>1)showTop(helpList.at(1));
			else QApplication::beep();
			break;
		case Key_F6 :
		_lnk_:	((Filesan *)parentWidget())->doProEdit( __from_unicode(brow->selectedText()), st==ControlButton);
			break;
		case Key_F8 : loadSearchModify((Filesan *)parentWidget());
			break;
		case Key_F11 : {
				char *ptxt=strdup(fileNam);
				*strrchr(ptxt, '/')=0;
				((Filesan *)parentWidget())->openSelect(ptxt, strrchr(fileNam,'/')+1);
				free(ptxt);
				}
				break;
		case Key_F7 : QApplication::clipboard()->setText(topLevelWidget()->caption(), QClipboard::Clipboard);
				break;
	       case Key_F12 : showTop(parentWidget());
	}
}

bool HelpWdg::event( QEvent *e)
{
int t, i, C;
switch(e->type() ){
case QEvent::Close : if(fileNam){
	HelpWdg *hlp;
	C=helpList.count();
	hide();
	for(t=1; t<C; t++)
	  for(i=0; (hlp=helpList.at(i)); i++)
		if(hlp->fileNam && hlp->_numb==t&&t>_numb&&strcmp(hlp->fileNam, fileNam)==0){
			hlp->_numb--;
			hlp->setTitle(strCodec->toUnicode(fileNam));
//			helpList.remove(hlp);
			break;
			}
	free((void *)fileNam);
	}
	helpList.remove(this);
	break;
case QEvent::KeyPress : 
	keysFunc(((QKeyEvent *)e)->key(),((QKeyEvent *)e)->state());
	break;
case QEvent::WindowDeactivate :
case QEvent::WindowActivate : // first than WindowActivate //先失去焦点，后再另设焦点
	if(helpList.count()>1 && helpList.remove(this) )helpList.prepend(this);
	break;
case QEvent::ShowNormal : 
	tms=0;
	tmId=startTimer(60);
	return true;
case QEvent::Timer :
	if(++tms>5){
		killTimer(tmId);
		raise();	setActiveWindow();
		}
	return true;
}
return QMainWindow::event(e);
}

static QMetaObjectCleanUp cleanUp_HelpWdg( helpwdg, &HelpWdg::staticMetaObject );
QMetaObject *HelpWdg::metaObj = 0;
const QMetaData	popActSlot={ "popAct(int)", &slot_int,  QMetaData::Private },
	closeAllWdgSlot={ "closall()",&slot_0_0, QMetaData::Private },
	recentSlot={ "recent()",&slot_0_0, QMetaData::Private },
	lnkopenSlot={ "lnkopen()" ,&slot_0_0, QMetaData::Private },
	selAsSrcSlot={"selAs()", &slot_0_0, QMetaData::Private },
	closeAllSlot={ "closeAll()", &slot_0_0,  QMetaData::Private },
	proEditSlot={ "proEdit()", &slot_0_0, QMetaData::Private };

QMetaObject *HelpWdg::staticMetaObject()
{
 if(metaObj==0){
 static const QMetaData help_slots[]={
	helpSlot,
	{"pluzone()", &slot_0_0, QMetaData::Private },
	{"email()", &slot_0_0, QMetaData::Private},
	findSlot,
	find2Slot,// dlg_findnext

	codecSlot,
	popCodecMenuSlot,
	selAsSrcSlot,

	popPluzoneSlot,
	lnkopenSlot,
	recentSlot,
	closeAllWdgSlot,
	menuOpenSlot, //12
	popActSlot,
	clearBrwSlot,
	closeAllSlot,
	{"fresh()" ,&slot_0_0, QMetaData::Private },
	proEditSlot,
	PZpathSlot,
	clippathSlot
	};
  metaObj = QMetaObject::new_metaobject(helpwdg, QMainWindow::staticMetaObject(), help_slots,  20,
	0, 0,
#ifndef QT_NO_PROPERTIES
	0, 0,
	0, 0,
#endif // QT_NO_PROPERTIES
	0, 0 );
    cleanUp_HelpWdg.setMetaObject( metaObj );
    }
  return metaObj;
}

QString hfnd;
bool HelpWdg::qt_invoke( int Id, QUObject* quo )
{
int id=Id-staticMetaObject()->slotOffset();
  switch( id ){
  case 0 : 
  case 1 :
  case 2 : fsplusBrows(id);
	break;
  case 3 : //buttonMsg=0;
  case 4 :	if( id==3 || hfnd.length()<1 ){
	InputDlg fndwdg(this, 1, pms_hlpChks, searchImg);
	Msg=fndwdg.exe(hfnd, brow->selectedText(), p_helpfnd, NULL, NULL);
	if((Msg&7)!=0/* btn-index */)return false;
	pms_hlpChks=Msg;
	}
	if(brow->find(hfnd, Msg&chkCase, Msg&chkWord, (Msg&chkBackward)==0)==false )
		infoWidget(hfnd, NULL, infoNoFound, this );
	break;
   case 8 : keysFunc(Key_F12, 0);
	break;
   case 18 : keysFunc(Key_F11, 0);
	break;
   case 19 : keysFunc(Key_F7, 0);
	break;
   case 9 : keysFunc(Key_L, AltButton);
	break;
   case 10 : keysFunc(Key_F5, 0);
	break;
   case 11 :  keysFunc(Key_Q, ControlButton);
	break;
   case 12 : browsHtml(parentWidget(), menubrows.lstIndex(quo[1].payload.i), menuClickStat&Qt::ControlButton);
	break;
   case 13 : 
	showTop(helpList.at(quo[1].payload.i));
	break;
   case 14 : menubrows.resetMem(NULL);
	break;
   case 15 : close();
	while(helpList.at(0))helpList.at(0)->close();
	break;
   case 16 : //initForBrows(caption());
	goto _fresh_;
   case 17 : ((Filesan *)parentWidget())->doProEdit(fileNam, false);
	break;
   case 7 : selAsSrc.resetMem(strdup(brow->selectedText()), ";\n");
	((Filesan *)parentWidget())->setCopyStats(selAsSrc.bufferString('\n') );
//	selAsSrc.memDiv("\n");
	break;
   case 5 : _codec=quo[1].payload.i;
	_fresh_: {
	unsigned int L;
	char *buf=ReadFile(fileNam, &L, 0, this, &pathList);
	if(buf&&buf!=fileNam)setTextEdit(brow, buf, L, _codec);
	}
	break;
   case 6 :	{
	ActMenu pop(this);
	QPopupMenu menu(this);
	popCodecMenu(this, &pop, &menu, -2/* disable defaultCode*/, _codec );
	pop.exec(QCursor::pos());
	// _pop->clear();
	}
	break;
   default : return QMainWindow::qt_invoke(Id, quo);
  }
return true;
}

