/*
	Write by xempo Nov 2015
	Free under LGPL
*/

#include "tabwdg.h"

TabWdg::TabWdg(QWidget *p, int idx) : QWidget(p)
{
pmIdx=idx;
}

void TabWdg::init(const char **chs, int tabw, int fntSz, int id)
{
	QFont fnt;
	if(ReadFont(fnt, id)==false)fnt=font();
	QLabel *fntLab=new QLabel(QString::fromUtf8(chs[1]/*prgfontChs*/), this);
	QLabel *szLab=new QLabel(QString::fromUtf8(chs[2]/*fntSzChs*/), this);
	fntLab->setAlignment(Qt::AlignCenter);
	szLab->setAlignment(Qt::AlignCenter);
	comboFont = new QComboBox( false, this );
	QFontDatabase db;
	comboFont->insertStringList( db.families() );
	comboFont->setCurrentText( fnt.family() );
	comboSize = new QComboBox( false, this );
	QValueList<int> sizes = db.standardSizes();
	QValueList<int>::Iterator it1 = sizes.begin();
	while( it1 != sizes.end() ){
		comboSize->insertItem( QString::number( *it1 ) );
		++it1;
		}
	comboSize->setCurrentText( QString::number( fnt.pointSize() ) );

	boldChk=new QCheckBox(QString::fromUtf8(chs[3]/*boldChs*/), this);
	italicChk=new QCheckBox(QString::fromUtf8(chs[4]/*italicChs*/), this);
	underlineChk=new QCheckBox(QString::fromUtf8(chs[5]/*underlineChs*/), this);
	boldChk->setChecked(fnt.bold());
	italicChk->setChecked(fnt.italic());
	underlineChk->setChecked(fnt.underline());
	fntLab->setGeometry(scaleRect(30, 40, fntSz*4, fntSz*3/2) );
	comboFont->setGeometry(scaleRect(31+fntSz*4, 40, 210, fntSz*3/2) );
	szLab->setGeometry(scaleRect(30, 80, fntSz*4, fntSz*3/2) );
	comboSize->setGeometry(scaleRect(31+fntSz*4, 80, fntSz*6, fntSz*3/2) );
	boldChk->setGeometry(scaleRect(54, 126, fntSz*6, fntSz*3/2) );
	italicChk->setGeometry(scaleRect(54, 126+fntSz*3/2, fntSz*6, fntSz*3/2) );
	underlineChk->setGeometry(scaleRect(54, 126+fntSz*3, fntSz*6, fntSz*3/2) );
	QFrame *line=new QFrame(this);
	line->setFrameStyle( QFrame::HLine | QFrame::Sunken );
	line->setGeometry(fntSz, scalefloat(126+fntSz*11/2), tabw-2*fntSz, 6);
	Chk1=new QCheckBox(QString::fromUtf8(chs[6]), this);
	Chk1->setChecked(__params[pmIdx]);
	Chk1->setGeometry(scaleRect(54, 126+fntSz*7, fntSz*16, fntSz*3/2));
	((QTabWidget *)parentWidget())->addTab(this, QString::fromUtf8(chs[0]));
}

void TabWdg::closing()
{
__params[pmIdx]=Chk1->isChecked();
}
